package jip;
import jip.*;

	/**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Clase empleada para el calculo del histograma de imagenes de tipo REAL. Este tipo de imagenes
  * tiene intensidades de pixel entre [0..1], por un conjunto infinito de intensidades se requiere 
  * para el calculo esta clase, la cual proporciona por cada ocurrecia de la misma una intensidad
  * junto con su numero de ocurrencias. Los datos internos son:
  * float intensidad: es la intensidad toma valores entre [0..1].
  * int nOcurrencias; el el numero de ocurrencias para esta intensidad.
  */

public class RealDataHistogram {
 
		/** Intensidad del pixel */
    private float intensidad;
    /** Nmero de ocurrencias */
    private int nOcurrencias;
    
    /**<P><FONT COLOR="red">
    *<B>Descripcin:</B><BR>
    *<FONT COLOR="blue">
    * Constructor de la clase. Inicializa la intensidad y el numero de ocurrencias a -1.
    */
    public RealDataHistogram() {
    	this.nOcurrencias=-1;
    	this.intensidad  =-1;
    }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Metodo para obtener el valor de la intensidad.
  * @return Valor de la intensidad.
  */
		public float getIValue (){
			return intensidad;
		}
    
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Metodo para obtener el valor de las ocurrencias.
  * @return Numero de ocurrencias.
  */
    public int getOValue (){
			return nOcurrencias;
		}
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Metodo para asignar valor a la intensidad.
  * @param Valor de la intensidad.
  */
    public void setIValue (float in){
			this.intensidad  =in;
    }  

  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Metodo para asignar valor a las ocurrencias.
  * @param Numero de ocurrencias.
  */  
    public void setOValue (int nOcu){
			this.nOcurrencias  =nOcu;
    }  

}