package jip;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import jip.*;

	/**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Clase declarada para emplearla en la clase HistogramWindow, su objeto es poder 
  * mostrar la imagen del histograma sobre las estructuras de Swing. Su uso es:
  * JIPImage -> ImageIcon -> ScrollablePicture -> JScrollPane -> JPanel.
  */

public class ScrollablePicture extends JLabel implements Scrollable {
  
  	/** Unidad de Incremento Mximo*/
    private int maxUnitIncrement = 1;
    /** Botn */
    private JToggleButton isMetric;
    /** Imagen */
    private ScrollablePicture picture;
    
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Contructor de la clase:
  * @param ImageIcon i, Esta sera la imagen a mostrar.
  * @param int m, Unidad de incremento maximo.
  */

    public ScrollablePicture(ImageIcon i, int m) {
      super(i);
	    maxUnitIncrement = m;
    }

	/**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Obtiene la Dimensin 
  * @return Dimension
  */

    public Dimension getPreferredScrollableViewportSize() {
	    return getPreferredSize();
    }

	public int getScrollableUnitIncrement(Rectangle visibleRect, int orientation, int direction) {
      int currentPosition = 0;
      if (orientation == SwingConstants.HORIZONTAL)
          currentPosition = visibleRect.x;
      else
          currentPosition = visibleRect.y;
    
      if (direction < 0) {
          int newPosition = currentPosition - (currentPosition / maxUnitIncrement) * maxUnitIncrement;
          return (newPosition == 0) ? maxUnitIncrement : newPosition;
      } 
      else{
          return ((currentPosition / maxUnitIncrement) + 1) * maxUnitIncrement - currentPosition;
      }
    }

    public int getScrollableBlockIncrement(Rectangle visibleRect, int orientation, int direction) {
	    if (orientation == SwingConstants.HORIZONTAL)
	      return visibleRect.width - maxUnitIncrement;
	    else
	      return visibleRect.height - maxUnitIncrement;
    }

    public boolean getScrollableTracksViewportWidth() {
	    return false;
    }

    public boolean getScrollableTracksViewportHeight() {
	    return false;
    }

    public void setMaxUnitIncrement(int pixels) {
	    maxUnitIncrement = pixels;
    }
}