package jipfunc;

import jip.*;
import java.util.Vector;

/**
* <P><FONT COLOR="red">
*<B>FAddPointt:</B> Aade un punto a una imagen tipo punto<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Aade un punto, cuyas coordenadas pasamos por
*parmetros, a una imgen de tipo POINT.<BR>
*Aplicable a tipos: PUNTO<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>X Origen: Coordenada X<BR>
*<li>Y Origen: Coordenada Y<BR><BR>
*</ul>
<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen de Tipo Punto (la misma que de entrada) con un 
*nuevo punto cuyas coordenadas corresponden a los parmetros
*de entrada<BR><BR>
*</ul>
*/

public class FAddPoint extends JIPFunction {

		/**
		*<P><FONT COLOR="red">
		*Constructor de la Clase.<BR>
		*<P><FONT COLOR="blue">		
		*Obtiene los parmetros de entrada para aplicar la funcin.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		*/

    public FAddPoint() {
		//Nombre y descripcion de la Funcion
	    name="FAddPoint";
	    description=
	         "Aade un punto a una imagen tipo punto";

	    //Definicion de Parametros
		  JIPParameter p1=new JIPParameter("x0",JIP.pINT,true);
      p1.setDescription("X origen");
      JIPParameter p2=new JIPParameter("y0",JIP.pINT,true);
      p2.setDescription("Y origen");
      
       //Asignacion de Parametros
      params=new Vector();
	    params.addElement(p1);
      params.addElement(p2);
  }

		/**
		*<P><FONT COLOR="red">
		*Mtodo Principal<BR>
		*<P><FONT COLOR="blue">		
		*Se le llama para aadir un nuevo punto a la imgen
		*de entrada.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>img: Imagen a procesar<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>Imagen con nuevo punto aadido.<BR><BR>
		*</ul>
		*/


    
    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
    int x0=((JIPParameter)params.elementAt(0)).getValueInt();
    int y0=((JIPParameter)params.elementAt(1)).getValueInt();
  
    if (img==null) return null; //Filtro de imagen nula
    res=new JIPImage(img);
		int w=img.getWidth();
		int h=img.getHeight();
	  int t=img.getType();
    if (t!=JIP.tPOINT || x0<0 || y0<0 || 
        x0>w-1 || y0>h-1) return null;
    img.addPoint(x0,y0);
    res=new JIPImage(img);
		return res;
	}
}