package jipfunc;

import jip.*;
import java.util.Vector;

/**
* <P><FONT COLOR="red">
*<B>FAddSegment:</B> Aade un segmento a una imagen tipo segmento<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Aade un segmento, cuyas coordenadas pasamos por
*parmetros, a una imgen de tipo SEGMENT.<BR>
*Aplicable a tipos: SEGMENTO<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>X Origen: Coordenada X del Origen<BR>
*<li>Y Origen: Coordenada Y del Origen<BR>
*<li>X Destino: Coordenada X del Destino<BR>
*<li>Y Destino: Coordenada Y del Destino<BR><BR>
*</ul>
<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen de Tipo Segmento (la misma que de entrada) con un 
*nuevo segmento cuyas coordenadas corresponden a los parmetros
*de entrada<BR><BR>
*</ul>
*/

public class FAddSegment extends JIPFunction {

		/**
		*<P><FONT COLOR="red">
		*Constructor de la Clase.<BR>
		*<P><FONT COLOR="blue">		
		*Obtiene los parmetros de entrada para aplicar la funcin.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		*/

    public FAddSegment() {
		//Nombre y descripcion de la Funcion
	    name="FAddSegment";
	    description=
	         "Aade un segmento a una imagen tipo segmento";

	    //Definicion de Parametros
		  JIPParameter p1=new JIPParameter("x0",JIP.pINT,true);
      p1.setDescription("X origen");
      JIPParameter p2=new JIPParameter("y0",JIP.pINT,true);
      p2.setDescription("Y origen");
      JIPParameter p3=new JIPParameter("x1",JIP.pINT,true);
      p3.setDescription("X destino");
      JIPParameter p4=new JIPParameter("y1",JIP.pINT,true);
      p4.setDescription("Y destino");
       //Asignacion de Parametros
      params=new Vector();
	    params.addElement(p1);
      params.addElement(p2);
      params.addElement(p3);
      params.addElement(p4);


    }

		/**
		*<P><FONT COLOR="red">
		*Mtodo Principal<BR>
		*<P><FONT COLOR="blue">		
		*Se le llama para aadir un nuevo segmento a la imgen
		*de entrada.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>img: Imagen a procesar<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>Imagen con nuevo segmento aadido.<BR><BR>
		*</ul>
		*/


    
    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
    int x0=((JIPParameter)params.elementAt(0)).getValueInt();
    int y0=((JIPParameter)params.elementAt(1)).getValueInt();
    int x1=((JIPParameter)params.elementAt(2)).getValueInt();
    int y1=((JIPParameter)params.elementAt(3)).getValueInt();
    if (img==null) return null; //Filtro de imagen nula
    res=new JIPImage(img);
		int w=img.getWidth();
		int h=img.getHeight();
	  int t=img.getType();
    if (t!=JIP.tSEGMENT || x0<0 || y0<0 || x1<0 || y1<0 ||
        x0>w-1 || y0>h-1 || x1>w-1 || y1>h-1) return null;
    img.addSegment(x0,y0,x1,y1);
    res=new JIPImage(img);
		return res;
	}
}