package jipfunc;

import jip.*;
import java.util.Vector;

/**
* <P><FONT COLOR="red">
*<B>FBinarize:</B> Convierte una imagen tipo BYTE a binaria (A 1 el rango: [u1,u2])<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Convierte la imagen de entrada de tipo BYTE a una imagen
*de tipo Binario. Para ello, pondr a valor 1 en la imagen binaria el
*rango de valores de la imagen original comprendido entre los dos
*umbrales de entrada.<BR>
*Aplicable a tipos: BYTE<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>u1 : Umbral inferior del rango a considerar como 1<BR>
*<li>u2: Umbral superior del rango a considerar como 1<BR><BR>
*</ul>
<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen de tipo Binario equivalente a la imagen de entrada de tipo
*BYTE.<BR><BR>
*</ul>
*/

public class FBinarize extends JIPFunction {
		/**
		*<P><FONT COLOR="red">
		*Constructor de la Clase.<BR>
		*<P><FONT COLOR="blue">		
		*Obtiene los parmetros de entrada para aplicar la funcin.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		*/

    public FBinarize() {
		//Nombre y descripcion de la Funcion
	    name="FBinarize";
	    description=
	         "Convierte una imagen tipo BYTE a binaria (A 1 el rango: [u1,u2])";

	    //Definicion de Parametros
		JIPParameter p1=new JIPParameter("u1",JIP.pINT,false);
		p1.setDefault(128);
		p1.setDescription("Umbral inferior del rango a considerar como 1");
		JIPParameter p2=new JIPParameter("u2",JIP.pINT,false);
		p2.setDefault(255);
		p2.setDescription("Umbral superior del rango a considerar como 1");

		//Asignacion de Parametros
        params=new Vector();
		params.addElement(p1);
		params.addElement(p2);
    }
    /**
		*<P><FONT COLOR="red">
		*Mtodo Principal<BR>
		*<P><FONT COLOR="blue">		
		*Se le llama para procesar la imgen y convertirla a tipo BYTE,
		*segn los umbrales que el usuario define.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>img: Imagen a procesar<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>Imagen de tipo Binario equivalente a la imagen de
		*entrada (de tipo BYTE).<BR><BR>
		*</ul>
		*/

    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
		int p1=getParamValueInt("u1");
		int p2=getParamValueInt("u2");
		if(img!=null&&img.getType()==JIP.tBYTE) {
			int w=img.getWidth();
			int h=img.getHeight();
			int b=img.getNumBands();
			res=new JIPImage(b,w,h,JIP.tBIT);
			for(int nb=0;nb<b;nb++) {
				int[] bmp=img.getAllPixel(nb);
				int[] bin=new int[w*h];
				for(int i=0;i<w*h;i++)
					bin[i]=(bmp[i]>=p1&&bmp[i]<=p2)?1:0;
				res.setAllPixel(nb,bin);
			}
		}
		return res;
	}
}