package jipfunc;

import jip.*;
import java.util.Vector;

/**
* <P><FONT COLOR="red">
*<B>FBrightness:</B> Ajusta el brillo de una imagen<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Ajusta el brillo de la imagen de entrada<BR>
*Aplicable a tipos: BYTE, WORD, COLOR y REAL<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>porcentaje: Porcentaje (100% no altera la imagen)<BR>
*</ul>
<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen procesada del mismo tipo que la imagen de entrada
*con nuevos valores de brillo<BR><BR>
*</ul>
*/


public class FBrightness extends JIPFunction {
		/**
		*<P><FONT COLOR="red">
		*Constructor de la Clase.<BR>
		*<P><FONT COLOR="blue">		
		*Obtiene los parmetros de entrada para aplicar la funcin.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		*/

    public FBrightness() {
		//Nombre y descripcion de la Funcion
	    name="FBrightness";
	    description="Ajusta el brillo de una imagen";

	    //Definicion de Parametros
		JIPParameter p1=new JIPParameter("porcentaje",JIP.pINT,false);
		p1.setDefault(100);
		p1.setDescription("Porcentaje (100% no altera la imagen)");

		//Asignacion de Parametros
    params=new Vector();
		params.addElement(p1);

    }

		/**
		*<P><FONT COLOR="red">
		*Mtodo Principal<BR>
		*<P><FONT COLOR="blue">		
		*Se le llama para aumentar el brillo de la imagen de entrada.<BR>
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>img: Imagen a procesar<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>Imagen del mismo tipo que la imagen de entrada pero con el
		*brillo alterado.<BR><BR>
		*</ul>
		*/

    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
		JIPImage res2=null;
		int p1=((JIPParameter)params.elementAt(0)).getValueInt();
                int t=img.getType();		
                int w=img.getWidth();
		int h=img.getHeight();
		int b=img.getNumBands();
		int max;
                switch(t) {
			    	case JIP.tBYTE:  max=255;   break;
				case JIP.tWORD:  max=65535; break;
				case JIP.tCOLOR: max=255;   break;
				case JIP.tREAL:  max=1;     break;
				default: return null;
			}

		res=new JIPImage(b,w,h,t);
		for(int nb=0;nb<b;nb++) 
	           {
		    if (t!=JIP.tREAL)
                       {		  
  			int[] bmp=img.getAllPixel(nb);
		    	int[] bin=new int[w*h];
		    	for(int i=0;i<w*h;i++)
                        bin[i]=Math.min((int)((float)bmp[i]*((float)p1/100)),max);
                        res.setAllPixel(nb,bin);
		       }
                    else
                       {		  
  			float[] bmp=img.getAllPixelFlo(nb);
		    	float[] bin=new float[w*h];
		    	for(int i=0;i<w*h;i++)
                        bin[i]=Math.min(((float)bmp[i]*((float)p1/100)),max);
                        res.setAllPixel(nb,bin);
		       }
		   }

		return res;
	}
}