package jipfunc;

import jip.*;
import java.util.Vector;
/**
* <P><FONT COLOR="red">
*<B>FContrast:</B> Ajusta el contraste de una imagen<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Ajusta el contraste de la imagen de entrada<BR>
*Aplicable a tipos: BYTE, WORD, COLOR y REAL<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>porcentaje: Porcentaje (100% no altera la imagen)<BR>
*</ul>
<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen procesada del mismo tipo que la imagen de entrada
*con nuevos valores de contraste<BR><BR>
*</ul>
*/

public class FContrast extends JIPFunction {
		/**
		*<P><FONT COLOR="red">
		*Constructor de la Clase.<BR>
		*<P><FONT COLOR="blue">		
		*Obtiene los parmetros de entrada para aplicar la funcin.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		*/

    public FContrast() {
		//Nombre y descripcion de la Funcion
	    name="FContrast";
	    description=
	         "Ajusta el contraste de una imagen";

	    //Definicion de Parametros
		JIPParameter p1=new JIPParameter("porcentaje",JIP.pINT,false);
		p1.setDefault(100);
		p1.setDescription("Porcentaje (100% no altera la imagen)");

		//Asignacion de Parametros
        params=new Vector();
		params.addElement(p1);

    }

		/**
		*<P><FONT COLOR="red">
		*Mtodo Principal<BR>
		*<P><FONT COLOR="blue">		
		*Se le llama para aumentar el contraste de la imagen de entrada.<BR>
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>img: Imagen a procesar<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>Imagen del mismo tipo que la imagen de entrada pero con el
		*contraste alterado.<BR><BR>
		*</ul>
		*/

    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
		int p1=((JIPParameter)params.elementAt(0)).getValueInt();
    int t=img.getType();		
    int w=img.getWidth();
		int h=img.getHeight();
		int b=img.getNumBands();
		int max;
    double porcentaje=p1;
		double i=1-(porcentaje/100.0);
		double j=porcentaje/100.0;
    res=new JIPImage(b,w,h,t);
    switch(t) {
				case JIP.tBYTE:  max=255;   break;
				case JIP.tWORD:  max=65535; break;
				case JIP.tCOLOR: max=255;   break;
				case JIP.tREAL:  max=1;     break;
				default: return null;
			}

		for(int nb=0;nb<b;nb++) 
       {
		    if (t!=JIP.tREAL)
		     {
  		  	int[] bmp=img.getAllPixel(nb);
		    	int[] bin=new int[w*h];
		        
         	for (int k=0;k<w*h;k++)
           {
            bin[k]=bmp[k]; 
            bin[k]=bin[k]-(max/2);
            bin[k]=(int)(bin[k]*((float)p1/100.0)+0.5);
            if (bin[k]<-(max/2)) bin[k]=-max/2;
            if (bin[k]>(max/2)) bin[k]=max/2;
            bin[k]+=(max/2.0);
           }
         	res.setAllPixel(nb,bin);
		     }
       else
         {
          float[] bmp=img.getAllPixelFlo(nb);
          float[] bin=new float[w*h];
            
           for (int k=0;k<w*h;k++)
           {
            bin[k]=bmp[k]; 
            bin[k]=bin[k]-((float)max/2);
            bin[k]=(float)(bin[k]*((float)p1/100.0));
            if (bin[k]<-(max/2.0)) bin[k]=(float)(-(float)max/2.0);
            if (bin[k]>(max/2.0)) bin[k]=(float)((float)max/2.0);
            bin[k]+=(float)((float)max/2.0);
           }
           res.setAllPixel(nb,bin);
         }

		   }
		return res;
	}
}