package jipfunc;

import jip.*;
import java.util.Vector;

/**
* <P><FONT COLOR="red">
*<B>FCrop:</B> Recorta una zona rectangular de una imagen<BR>
*<FONT COLOR="blue">
*DESCRIPCION: El usuario introduce las coordenadas de la imagen a
*partir de las cuales va a crear una nueva imagen.<BR>
*Aplicable a tipos: BIT, BYTE, WORD, COLOR y REAL<BR>
*Usa: FEqualize<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>x: Coordenada x de la esquina superior izqda. del recorte<BR>
*<li>y: Coordenada y de la esquina superior izqda. del recorte<BR>
*<li>w: Anchura del rectangulo de recorte<BR>
*<li>h: Altura del rectangulo de recorte<BR><BR>
*</ul>
<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen recortada del mismo tipo que la imagen de entrada<BR><BR>
*</ul>
*/


public class FCrop extends JIPFunction {

		/**
		*<P><FONT COLOR="red">
		*Constructor de la Clase.<BR>
		*<P><FONT COLOR="blue">		
		*Obtiene los parmetros de entrada para aplicar la funcin.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		*/


    public FCrop() {
		//Nombre y descripcion de la Funcion
	    name="FCrop";
	    description=
	         "Recorta una zona rectangular de una imagen";

	    //Definicion de Parametros
		JIPParameter p1=new JIPParameter("x",JIP.pINT,false);
		p1.setDefault(0);
		p1.setDescription("Coordenada x de la esquina superior izqda. del recorte");
		JIPParameter p2=new JIPParameter("y",JIP.pINT,false);
		p2.setDefault(0);
		p2.setDescription("Coordenada y de la esquina superior izqda. del recorte");
		JIPParameter p3=new JIPParameter("w",JIP.pINT,true);
		p3.setDescription("Anchura del rectangulo de recorte");
		JIPParameter p4=new JIPParameter("h",JIP.pINT,true);
		p4.setDescription("Altura del rectangulo de recorte");

		//Asignacion de Parametros
        params=new Vector();
		params.addElement(p1);
		params.addElement(p2);
		params.addElement(p3);
		params.addElement(p4);
    }
    
    /**
		*<P><FONT COLOR="red">
		*Mtodo Principal<BR>
		*<P><FONT COLOR="blue">		
		*Se le llama recortar la imagen de entrada, creando una
		*nueva imagen con esa seccin recortada.<BR>
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>img: Imagen a procesar<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>Imagen recortada del mismo tipo que la imagen de entrada<BR><BR>
		*</ul>
		*/
    
    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
		int xrec=getParamValueInt("x");
		int yrec=getParamValueInt("y");
		int wrec=getParamValueInt("w");
		int hrec=getParamValueInt("h");
		int ipix;
		float fpix;
		if(img!=null) {
			int w=img.getWidth();
			int h=img.getHeight();
			int b=img.getNumBands();
			int t=img.getType();
			if(xrec>=0 && yrec>=0 && xrec<w && yrec<h && wrec>0 && hrec>0) {
				res=new JIPImage(b,wrec,hrec,t);
				for(int nb=0;nb<b;nb++)
					for(int y=0;y<hrec;y++)
						for(int x=0;x<wrec;x++) {
							if(t!=JIP.tREAL) {
								ipix=(xrec+x<w&&yrec+y<h)?img.getPixel(nb,xrec+x,yrec+y):0;
								res.setPixel(nb,x,y,ipix);
							}
							else {
								fpix=(xrec+x<w&&yrec+y<h)?img.getPixelFlo(nb,xrec+x,yrec+y):0;
								res.setPixel(nb,x,y,fpix);
							}
						}
			}
		}
		return res;
	}
}