package jipfunc;

import jip.*;
import java.util.Vector;
import java.util.Random;

/**
* <P><FONT COLOR="red">
*<B>FEqualize:</B> Realiza la ecualizacin del histograma<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Ecualizacin de la imgen de entrada. 
*En sta funcin no se tratan datos geomtricos.<BR>
*Aplicable a tipos: BIT,BYTE, WORD, COLOR y REAL<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR><BR>
*</ul>
<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen procesada despus de haber realizado la ecualizacin<BR><BR>
*</ul>
*/

public class FEqualize extends JIPFunction {
		/**
		*<P><FONT COLOR="red">
		*Constructor de la Clase.<BR>
		*<P><FONT COLOR="blue">		
		*Obtiene los parmetros de entrada para aplicar la funcin.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		*/

    public FEqualize() {
		//Nombre y descripcion de la Funcion
	    name="FEqualize";
	    description=
	         "Equalizacion del histograma";
    }
    
    /**
		*<P><FONT COLOR="red">
		*Mtodo Principal<BR>
		*<P><FONT COLOR="blue">		
		*Se le llama para procesar la imgen realizando la ecualizacin de sta<BR>
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>img: Imagen a procesar<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>Imagen procesada despus de haber realizado la ecualizacin<BR><BR>
		*</ul>
		*/

    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
    
    // esta funcion no trata datos geometricos
    
    if (img.getType()==JIP.tPOINT && img.getType()==JIP.tSEGMENT &&
          img.getType()==JIP.tPOLY && img.getType()==JIP.tEDGES)  return img;        
      
    int t=img.getType();		
    int w=img.getWidth();
		int h=img.getHeight();
		int b=img.getNumBands();
    int max;
    switch(t) 
        {
         case JIP.tBYTE:  max=255;   break;
         case JIP.tCOLOR: max=255;   break;
         case JIP.tWORD:  max=65535; break;
         case JIP.tREAL:  max=1;     break;
         default: return null;
        }
    
    float bmp[]=new float[w*h];
    float bin[]=new float[w*h];
    res=new JIPImage(b,w,h,t);
    for(int nb=0;nb<b;nb++) 
      {
       float maxi=0,mini=1;
       if (t==JIP.tREAL) bmp=img.getAllPixelFlo(nb);
         else
          {
           int bmpAux[]=img.getAllPixel(nb);
           for (int a=0;a<w*h;a++) bmp[a]=(float)(bmpAux[a]/(float)max);
          }

       for (int k=0;k<w*h;k++)
        {
         if (bmp[k]<mini) mini=bmp[k];
         if (bmp[k]>maxi) maxi=bmp[k];
        }
       
       for (int k=0;k<w*h;k++)
        {
         bin[k]=(float)((bmp[k]-mini)*(1.0/(maxi-mini)));
        }
       
       if (t==JIP.tREAL) 
         { res.setAllPixel(nb,bin);}
       else
         {
          int binAux[]=new int[w*h];
          for (int a=0;a<w*h;a++) binAux[a]=(int)(bin[a]*(float)max+0.5);
          res.setAllPixel(nb,binAux);
         }
    }
     return res;
	}
}