package jipfunc;

import jip.*;
import java.util.Vector;

/**
* <P><FONT COLOR="red">
*<B>FGamma:</B> Ajusta las intensidades de las bandas de color de una imagen tipo COLOR<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Ajusta el brillo de las bandas de color de la imagen de entrada<BR>
*Aplicable a tipo: COLOR<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>r: Porcentaje Rojo<BR>
*<li>g: Porcentaje Verde<BR>
*<li>b: Porcentaje Azul<BR>
*</ul>
<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen procesada del mismo tipo que la imagen de entrada
*con nuevos valores de brillo para las bandas de color<BR><BR>
*</ul>
*/


public class FGamma extends JIPFunction {
		/**
		*<P><FONT COLOR="red">
		*Constructor de la Clase.<BR>
		*<P><FONT COLOR="blue">		
		*Obtiene los parmetros de entrada para aplicar la funcin.
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>NINGUNO<BR><BR>
		*</ul>
		*/

    public FGamma() {
		//Nombre y descripcion de la Funcion
	    name="FGamma";
	    description="Ajusta el brillo de las bandas de color de una imagen tipo COLOR";

	    //Definicion de Parametros
		JIPParameter p1=new JIPParameter("r",JIP.pINT,false);
		p1.setDefault(100);
		p1.setDescription("Porcentaje rojo");
		JIPParameter p2=new JIPParameter("g",JIP.pINT,false);
		p2.setDefault(100);
		p2.setDescription("Porcentaje verde");
		JIPParameter p3=new JIPParameter("b",JIP.pINT,false);
		p3.setDefault(100);
		p3.setDescription("Porcentaje azul");

		//Asignacion de Parametros
        params=new Vector();
		params.addElement(p1);
        params.addElement(p2);	
        params.addElement(p3);

    }

		/**
		*<P><FONT COLOR="red">
		*Mtodo Principal<BR>
		*<P><FONT COLOR="blue">		
		*Se le llama para ajustar las intensidades de las bandas de color de la imagen de entrada.<BR>
		*<ul><B>Parametros de Entrada:</B><BR>
		*<li>img: Imagen a procesar<BR><BR>
		*</ul>
		<ul><B>Parametros de Salida:</B><BR>
		*<li>Imagen del mismo tipo que la imagen de entrada pero con las
		*intensidades de las bandas de color alteradas.<BR><BR>
		*</ul>
		*/

    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
		JIPImage res2=null;
        int []color=new int[3];
		color[0]=((JIPParameter)params.elementAt(0)).getValueInt();
		color[1]=((JIPParameter)params.elementAt(1)).getValueInt();
		color[2]=((JIPParameter)params.elementAt(2)).getValueInt();
        
        int t=img.getType();		
        int w=img.getWidth();
		int h=img.getHeight();
		int b=img.getNumBands();
        if (t!=JIP.tCOLOR) return null;

		res=new JIPImage(b,w,h,t);
		for(int nb=0;nb<b;nb++) 
	           {
                int[] bmp=img.getAllPixel(nb);
		    	int [] bin=new int[w*h];
		    	for(int i=0;i<w*h;i++)
                        bin[i]=(int)Math.min(((float)bmp[i]*((float)color[nb]/100f)), 255);
                res.setAllPixel(nb,bin);
		       }
		return res;
	}
}