package jipfunc;

import jip.*;
import jiputil.*;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import javax.swing.*;          
import javax.swing.border.*;

/**
* <P><FONT COLOR="red">
*<B>FHistogram:</B> Calcula el histograma de una imagen.<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Calcula en histograma de la imagen de entrada.
*No se gestionan frames geometricos si se presentan, y no
*modifica el frame de entrada.<BR>
*Aplicable a tipos: BYTE, WORD, COLOR y REAL<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR><BR>
*</ul>
<ul><B>Parametros de Salida:</B><BR>
*<li>Grfico correspondiente al Histograma de la imagen de entrada<BR><BR>
*</ul>
*Notas Adicionales: No es en esta clase donde se efectuan los calculos
*sino que desde aqui se hace una llamada a jip.HistogramWindow pasndole 
*la imagen de la que queremos obtener el histograma.<BR>
*/

public class FHistogram extends JIPFunction {
	  /**
    *<P><FONT COLOR="red">
    *Constructor de la Clase.<BR>
    *<P><FONT COLOR="blue">    
    *Obtiene los parmetros de entrada para aplicar la funcin.
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    <ul><B>Parametros de Salida:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    */
    public FHistogram() {
		//Nombre y descripcion de la Funcion
	    name="FHistogram";
	    description="Realiza el histograma de la imagen (RGB)";

	    //Definicion de Parametros
	    //Sin Parametros

		//Asignacion de Parametros
        params=new Vector();
	  }
    
    
    /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *En este mtodo no es donde se realizan los calculos
    *sino que se realiza un filtrado de los tipos
    *geometricos para no procesarlos..
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar.<BR><BR>
    *</ul>
    <ul><B>Parametros de Salida:</B><BR>
    *<li> La misma imagen de entrada.<BR><BR>
    *</ul>
    */

   public JIPImage processImg(JIPImage img) {
      
      // esta funcion no trata datos geometricos
          
      if (img.getType()!=JIP.tPOINT && img.getType()!=JIP.tSEGMENT &&
          img.getType()!=JIP.tPOLY && img.getType()!=JIP.tEDGES){	
        JFrame frame = new jip.HistogramWindow(img);
        frame.setSize(290,405);
        frame.setVisible(true);
          }

			return img;
    }
}