package jipfunc;

import jip.*;
import java.util.Vector;
import java.lang.*;

    /**
    * <P><FONT COLOR="red">
    *<B>FMag:</B> Calculo de la magnitud de una imgen compleja<BR>
    *<FONT COLOR="blue">
    *DESCRIPCION: Calcula la magnitud de una imagen compleja mediante
    *el calculo de la raiz cuadrada de la suma de los
    *cuadrados de los pixels correspondientes a las bandas
    *pares e impares respectivamente.<BR>
    *Aplicable a tipos: BIT, BYTE, WORD, y REAL<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen de Entrada<BR>
    *<li>img: Imagen a Procesar con un nmero par de bandas.<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>El resultado es una imagen del mismo tipo que la imagen
    *de entrada y con la mitad de bandas<BR><BR>
    *</ul>
    */

public class FMag extends JIPFunction {
    

    /**
    *<P><FONT COLOR="red">
    *Constructor de la Clase.<BR>
    *<P><FONT COLOR="blue">    
    *Obtiene los parmetros de entrada para aplicar la funcin.
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    <ul><B>Parametros de Salida:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    */

		public FMag() {
		//Nombre y descripcion de la Funcion
	    name="FMag";
	    description=
	         "Calcula la magnitud de una imagen compleja";

		//Asignacion de Parametros
 	       params=new Vector();
	
    }
    
    /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *Se calcula la magnitud de la imagen de entrada<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Imagen con la mitad de bandas que la original.
    *que contiene la magnitud de la imagen original.<BR><BR>
    *</ul>
    */

    
    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;

		if(img!=null) {
			int w=img.getWidth();
			int h=img.getHeight();
			int b=img.getNumBands();
			int t=img.getType();
			res=new JIPImage(b/2,w,h,t);
			int cont=0;
			float ppflo,ppflo2;
			if (t==JIP.tBIT || t==JIP.tBYTE || t==JIP.tWORD) { // Si la imagen no es Real
				int[] bmp;
				int[] bmp2;
				int[] bin=new int[w*h];
				int pp,pp2;
				for (int z=0;z<b;z=z+2) { // Bucle de bandas
					bmp=img.getAllPixel(z);
					bmp2=img.getAllPixel(z+1);
			  	for (int x=0;x<w;x++) { //Eje X
			  		for (int y=0;y<h;y++) { // Eje Y
			  			pp=bmp[x+y*w];
		  			 	pp2=bmp2[x+y*w];
		  			 	// Calculamos la raiz Cuadrada de la suma de
		  			 	// los cuadrados de los pixels
		  			 	bin[x+y*w]=(int)Math.sqrt(pp*pp+pp2*pp2);
		  			}
			  	}  
			  	res.setAllPixel(cont,bin);
			  	cont++;
				}
			}  	
			else if (t==JIP.tREAL){// en el caso de que sea de tipo REAL
				float[] bmp;
				float[] bmp2;
				float[] bin=new float[w*h];
				float pp,pp2;
				for (int z=0;z<b;z=z+2) {
					bmp=img.getAllPixelFlo(z);
					bmp2=img.getAllPixelFlo(z+1);
			  	for (int x=0;x<w;x++) {
			  		for (int y=0;y<h;y++) {
			 				pp=bmp[x+y*w];
		  			 	pp2=bmp2[x+y*w];
		  			 	bin[x+y*w]=(float)Math.sqrt(pp*pp+pp2*pp2);
		  			}  
			  	}
			 		res.setAllPixel(cont,bin);
			 		cont++;
				}
			}	
			else return null;
		 }
		return res;
	}
}