package jipfunc;

import jip.*;
import java.util.Vector;

/**
* <P><FONT COLOR="red">
*<B>FNegate:</B> Calcula el negativo de una imagen<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Calcula el negativo de la imagen de entrada.<BR>
*Aplicable a tipos: BIT, BYTE, WORD, COLOR y REAL<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR><BR>
*</ul>
*<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen resultado de calcular el negativo de la imagen de entrada<BR><BR>
*</ul>
*Notas Adicionales: No se aplica a frames geomtricos.<BR>
*/


public class FNegate extends JIPFunction {

    /**
    *<P><FONT COLOR="red">
    *Constructor de la Clase.<BR>
    *<P><FONT COLOR="blue">    
    *Obtiene los parmetros de entrada para aplicar la funcin.
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    */

    public FNegate() {
		//Nombre y descripcion de la Funcion
	    name="FNegate";
	    description="Realiza el negativo de una imagen";

	    //Definicion de Parametros
	    //Sin Parametros
    }
    
    /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *Se le llama para calcular el negativo de la imagen.<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Imagen resultado de calcular el negativo de la imagen
    *de entrada.<BR><BR>
    *</ul>
    */

    
    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
		if(img!=null) {
			int w=img.getWidth();
			int h=img.getHeight();
			int b=img.getNumBands();
			int t=img.getType();
			int n=img.getNumPixels();
			int maximo=1;
      
			switch(t) {
				case JIP.tBIT: maximo=1; break;
				case JIP.tBYTE: maximo=255; break;
				case JIP.tWORD: maximo=65535; break;
				case JIP.tCOLOR: maximo=255; break;
        default: return res;
			}
			res=new JIPImage(b,w,h,t);
			int[] bmp=null;
			float[] bmpflo=null;
			for(int nb=0;nb<b;nb++) {
				if(t==JIP.tREAL) bmpflo=img.getAllPixelFlo(nb);
				else bmp=img.getAllPixel(nb);
				for(int i=0;i<n;i++) {
					if(t==JIP.tREAL) bmpflo[i]=1.0f-bmpflo[i];
					else bmp[i]=maximo-bmp[i];
				}				
				if(t==JIP.tREAL) res.setAllPixel(nb,bmpflo);
				else res.setAllPixel(nb,bmp);
			}
		}
		return res;
	}
}