package jipfunc;

import jip.*;
import java.util.Vector;
import java.util.Random;

/**
* <P><FONT COLOR="red">
*<B>FPixelate:</B> Asigna a todos los pixels de la mascara la intensidad promedio<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Asigna a todos los pixels de la ventana de vecindad del pixel que estamos
*tratando la intensidad promedio.<BR>
*Aplicable a tipos: BIT, BYTE, WORD, COLOR y REAL<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>lado: Longitud del lado<BR><BR>
*</ul>
*<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen Procesada del mismo tipo que la imagen de entrada<BR><BR>
*</ul>
*Notas Adicionales: No se aplica a frames geomtricos.<BR>
*/


public class FPixelate extends JIPFunction {

    /**
    *<P><FONT COLOR="red">
    *Constructor de la Clase.<BR>
    *<P><FONT COLOR="blue">    
    *Obtiene los parmetros de entrada para aplicar la funcin.
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    */

    public FPixelate() {
		//Nombre y descripcion de la Funcion
	    name="FPixelate";
	    description=
	         "Asigna a todos los pixels de la mascara la intensidad promedio";

	    //Definicion de Parametros
		JIPParameter p1=new JIPParameter("lado",JIP.pINT,false);
		p1.setDefault(2);
		p1.setDescription("Longitud de lado");

		//Asignacion de Parametros
        params=new Vector();
		params.addElement(p1);

    }

   /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *Se llama a este mtodo para sustituir cada pixel, por el
    *promedio de la ventana de vecindad de tamao especificado 
    *por el usuario.<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Imagen procesada, del mismo tipo que la imagen original.<BR><BR>
    *</ul>
    */

   public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
		int p1=((JIPParameter)params.elementAt(0)).getValueInt();
		Random rnd=new Random();
    int t=img.getType();		
    int w=img.getWidth();
		int h=img.getHeight();
		int b=img.getNumBands();
		int max;
    
    /** FILTRAMOS LA GEOMETRIA */   
    if (t!=JIP.tBIT && t!=JIP.tBYTE && t!=JIP.tWORD
        && t!=JIP.tREAL && t!=JIP.tCOLOR) 
          
          return res;
    
    res=new JIPImage(b,w,h,t);
		for(int nb=0;nb<b;nb++) {
		    if (t!=JIP.tREAL)
		      {
		 	int[] bmp=img.getAllPixel(nb);
	    	    	int[] bin=new int[w*h];
		    	
			for(int i=0; i<h; i+=p1)
		    	  for(int j=0; j<w; j+=p1)
			   {
			    int inicioX=j-p1, finX=j+p1;
			    int inicioY=i-p1, finY=i+p1;
			    if(inicioX<0) inicioX=0 ;  if(finX>=w) finX=w-1 ;
			    if(inicioY<0) inicioY=0 ;  if(finY>=h) finY=h-1 ;
			    int aux=0;
			    int cont=0,cont2=0;
			    for (int y=inicioY; y<=finY; y++)
			        for (int x=inicioX; x<=finX; cont++, x++)
				    aux+=bmp[x+y*w];
			    for (int y=inicioY; y<=finY; y++)
			        for (int x=inicioX; x<=finX; cont2++, x++)
				    bin[x+y*w]=aux/cont;
			   }
		    	res.setAllPixel(nb,bin);
		      }
		   else
		      {
		 	float[] bmp=img.getAllPixelFlo(nb);
	    	    	float[] bin=new float[w*h];
		    	for(int i=0; i<h; i+=p1)
		    	  for(int j=0; j<w; j+=p1)
			   {
			    int inicioX=j-p1, finX=j+p1;
			    int inicioY=i-p1, finY=i+p1;
			    if(inicioX<0) inicioX=0 ;  if(finX>=w) finX=w-1 ;
			    if(inicioY<0) inicioY=0 ;  if(finY>=h) finY=h-1 ;
			    float aux=1;
			    int cont=0,cont2=0;
			    for (int y=inicioY; y<=finY; y++)
			        for (int x=inicioX; x<=finX; cont++, x++)
				    aux+=bmp[x+y*w];
			    for (int y=inicioY; y<=finY; y++)
			        for (int x=inicioX; x<=finX; cont2++, x++)
				    bin[x+y*w]=aux/cont;

			   }
		    	res.setAllPixel(nb,bin);
		      }
                   }
	
		return res;
	}
}