package jipfunc;

import jip.*;
import java.util.Vector;
import java.util.Random;

/**
* <P><FONT COLOR="red">
*<B>FRandomPoint:</B> Introduce Puntos Aleatorios.<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Introduce un nmero de puntos aleatorios en la
*imagen, especificado por el usuario. La imagen debe ser de
*tipo Punto.<BR>
*Aplicable a tipos: POINT<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>numero: Nmero de puntos a introducir<BR><BR>
*</ul>
*<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen de entrada con los nuevos puntos aadidos.<BR><BR>
*</ul>
*/



public class FRandomPoint extends JIPFunction {

    /**
    *<P><FONT COLOR="red">
    *Constructor de la Clase.<BR>
    *<P><FONT COLOR="blue">    
    *Obtiene los parmetros de entrada para aplicar la funcin.
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>NINGUNO<BR><BR>
    *</ul>
    */

    public FRandomPoint() {
		//Nombre y descripcion de la Funcion
	    name="FRandomPoint";
	    description=
	         "Puntos Aleatorios";

	    //Definicion de Parametros
		  JIPParameter p1=new JIPParameter("numero",JIP.pINT,false);
      p1.setDescription("Numero de Puntos ");
      p1.setDefault(100);
       //Asignacion de Parametros
      params=new Vector();
	    params.addElement(p1);
      
    }

    /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *Se llama a este mtodo para introducir puntos aleatorios
    *en la imagen de entrada (que es de tipo Point).<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Imagen de entrada con los nuevos puntos aadidos.<BR><BR>
    *</ul>
    */

   
    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
		if (img==null) return null;
    int num=((JIPParameter)params.elementAt(0)).getValueInt();
    int w=img.getWidth();
		int h=img.getHeight();
		int b=img.getNumBands();
		int t=img.getType();
    if (t!=JIP.tPOINT || num<=0 || w<1 || h<1) return null;
    Random rnd=new Random();
    int x0,y0;
		for (int i=0;i<num;i++){
        x0=Math.abs(rnd.nextInt()%w);
        y0=Math.abs(rnd.nextInt()%h);
        img.addPoint(x0,y0);
  
    }
    
    res=new JIPImage(img);
		return res;
	}
}