package jipfunc;

import jip.*;
import java.util.Vector;
import java.lang.*;

/**
* <P><FONT COLOR="red">
*<B>FSkeleton:</B> Calcula el esqueleto de una imagen binaria<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Calcula el esqueleto correspondiente a 
*la imagen binaria de entrada.<BR>
*Aplicable a tipos: BIT<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR><BR>
*</ul>
*<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen binaria correspondiente al esqueleto de la imagen
*de entrada.<BR><BR>
*</ul>
*/


public class FSkeleton extends JIPFunction {

      /**
      *<P><FONT COLOR="red">
      *Constructor de la Clase.<BR>
      *<P><FONT COLOR="blue">    
      *Obtiene los parmetros de entrada para aplicar la funcin.
      *<ul><B>Parametros de Entrada:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      *<ul><B>Parametros de Salida:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      */

    public FSkeleton() { 
       	
		//Nombre y descripcion de la Funcion
	    name="FSkeleton";
	    description=
	         "Calcula el esqueleto de una imagen binaria";

		//Asignacion de Parametros
 	       params=new Vector();
	
    }
    
    /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *Este metodo es el encargado de recibir la imagen de entrada y 
    *calcular el esqueleto de ella.<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Imagen binaria correspondiente al esqueleto de la imagen
    *de entrada.<BR><BR>
    *</ul>
    */

    
    public JIPImage processImg(JIPImage img) {
		JIPImage res=null,aux=null;
		
		if(img!=null && img.getType()==JIP.tBIT) {
			int w=img.getWidth();
			int h=img.getHeight();
			int b=img.getNumBands();
			int t=img.getType();
			int cont=0;
			int[] bmp;
			int[] destino;
			res=new JIPImage(2*b,w,h,JIP.tBIT);
			aux=new JIPImage(b,w,h,JIP.tBIT);
			
			if (t==JIP.tBIT) { // Solo en caso de imagenes binarias
				boolean B4,B0,B6,B2;
				boolean[] o=new boolean[10];
				int fila,columna;
				boolean flag=false;
	  		bmp=img.getAllPixel(0);
	  		destino=img.getAllPixel(0);
	  		res.setAllPixel(0,bmp);												
				//for (int z=0;z<b;z=z++) { // Bucle de Bandas
						do {
							flag=false;					
					 		for (int x=1;x<w-1;x++) // EJE X
					 				for (int y=1;y<h-1;y++) { // EJE Y
					 					fila=x;
					 					columna=y;
					 					for (int pp=0;pp<10;pp++)
											o[pp]=false;

		  							if (bmp[fila+columna*w]==1) {
		  										
		  								// CALCULAMOS B4
		  								if (bmp[(fila)+(columna+1)*w]==1)
		  										o[0]=true;
		  								if (bmp[(fila-1)+(columna+1)*w]==1)
		  									  o[1]=true;
		  								if (bmp[(fila-1)+(columna)*w]==1)
		  									  o[2]=true;
		  								if (bmp[(fila-1)+(columna-1)*w]==1)
		  									  o[3]=true;
		  								if (bmp[(fila)+(columna-1)*w]==1)
		  									  o[4]=true;
		  							  if (bmp[(fila+1)+(columna-1)*w]==1)
		  							  	  o[5]=true;	
		  								if (bmp[(fila+1)+(columna)*w]==1)
		  									  o[6]=true;
		  								if (bmp[(fila+1)+(columna+1)*w]==1)
		  									  o[7]=true;
																		
		  								if ( o[0] && (o[1] || o[2] || o[6] || o[7])&& 
		  									 (o[2] || !(o[3]) ) && (!(o[5]) || o[6]) && !o[4]) {
		  			
		  										flag=true;
		  										destino[fila+columna*w]=0;
		  								}
		  							}			
		  								
		  					}// Del for del Eje y	
		  			aux.setAllPixel(0,destino);
		  		  bmp=aux.getAllPixel(0);
						
						
		        // AHORA CALCULAMOS B0
		        
		        for (int x=1;x<w-1;x++) // EJE X
					 				for (int y=1;y<h-1;y++) { // EJE Y
					 					fila=x;
					 					columna=y;
					 					for (int pp=0;pp<10;pp++)
											o[pp]=false;

		  							if (bmp[fila+columna*w]==1) {
		  								//System.out.println("ES UNO");
		  								// CALCULAMOS B0
		  								if (bmp[(fila)+(columna+1)*w]==1)
		  										o[0]=true;
		  								if (bmp[(fila-1)+(columna+1)*w]==1)
		  									  o[1]=true;
		  								if (bmp[(fila-1)+(columna)*w]==1)
		  									  o[2]=true;
		  								if (bmp[(fila-1)+(columna-1)*w]==1)
		  									  o[3]=true;
		  								if (bmp[(fila)+(columna-1)*w]==1)
		  									  o[4]=true;
		  							  if (bmp[(fila+1)+(columna-1)*w]==1)
		  							  	  o[5]=true;	
		  								if (bmp[(fila+1)+(columna)*w]==1)
		  									  o[6]=true;
		  								if (bmp[(fila+1)+(columna+1)*w]==1)
		  									  o[7]=true;
							
		  								if ( o[4]&&(o[2] || o[3] || o[5] || o[6])&& 
		  									 (o[6] || !(o[7]) ) && (!o[1] || o[2]) && !o[0]) {
		  									
		  										flag=true;
		  										destino[fila+columna*w]=0;
		  								}
		  								
		  							}			
		  								
		  					}// Del for del Eje y			
		        
		        aux.setAllPixel(0,destino);												
					  bmp=aux.getAllPixel(0);
        
        // AHORA CALCULAMOS B2
		        
		        for (int x=1;x<w-1;x++) // EJE X
					 				for (int y=1;y<h-1;y++) { // EJE Y
					 					fila=x;
					 					columna=y;
					 					for (int pp=0;pp<10;pp++)
											o[pp]=false;

		  							if (bmp[fila+columna*w]==1) {
		  								
		  								// CALCULAMOS B2
											if (bmp[(fila)+(columna+1)*w]==1)
		  										o[0]=true;
		  								if (bmp[(fila-1)+(columna+1)*w]==1)
		  									  o[1]=true;
		  								if (bmp[(fila-1)+(columna)*w]==1)
		  									  o[2]=true;
		  								if (bmp[(fila-1)+(columna-1)*w]==1)
		  									  o[3]=true;
		  								if (bmp[(fila)+(columna-1)*w]==1)
		  									  o[4]=true;
		  							  if (bmp[(fila+1)+(columna-1)*w]==1)
		  							  	  o[5]=true;	
		  								if (bmp[(fila+1)+(columna)*w]==1)
		  									  o[6]=true;
		  								if (bmp[(fila+1)+(columna+1)*w]==1)
		  									  o[7]=true;
							
		  								if ( o[6]&&(o[0] || o[4] || o[5] || o[7])&& 
		  									 (o[0] || !o[1] ) && (!o[3] || o[4]) && !o[2]) {
		  			
		  										flag=true;
		  										destino[fila+columna*w]=0;
		  								}
		  								
		  							}			
		  								
		  					}// Del for del Eje y			
		        
		        aux.setAllPixel(0,destino);												
					  bmp=aux.getAllPixel(0);
			
			// AHORA CALCULAMOS B6
		        
		        for (int x=1;x<w-1;x++) // EJE X
					 				for (int y=1;y<h-1;y++) { // EJE Y
					 					fila=x;
					 					columna=y;
					 					for (int pp=0;pp<10;pp++)
											o[pp]=false;

		  							if (bmp[fila+columna*w]==1) {
		  								
		  								// CALCULAMOS B6
											
							       	if (bmp[(fila)+(columna+1)*w]==1)
		  										o[0]=true;
		  								if (bmp[(fila-1)+(columna+1)*w]==1)
		  									  o[1]=true;
		  								if (bmp[(fila-1)+(columna)*w]==1)
		  									  o[2]=true;
		  								if (bmp[(fila-1)+(columna-1)*w]==1)
		  									  o[3]=true;
		  								if (bmp[(fila)+(columna-1)*w]==1)
		  									  o[4]=true;
		  							  if (bmp[(fila+1)+(columna-1)*w]==1)
		  							  	  o[5]=true;	
		  								if (bmp[(fila+1)+(columna)*w]==1)
		  									  o[6]=true;
		  								if (bmp[(fila+1)+(columna+1)*w]==1)
		  									  o[7]=true;

		  								if ( o[2] && (o[0] || o[1] || o[3] || o[4]) && 
		  									 (o[4] || !o[5] ) && (o[0] || !o[7]) && !o[6]) {
		  										flag=true;
		  										destino[fila+columna*w]=0;
		  								}
		  								
		  							}			
		  								
		  					}// Del for del Eje y			
		        
		        aux.setAllPixel(0,destino);												
					  bmp=aux.getAllPixel(0);

        //*/
					  	
						} while (flag!=false);
				  res.setAllPixel(1,bmp);												
				//} // Del for de las bandas
			
			} // De si la imagen es de tipo bit
							
			} // De si la imagen es distinta de NULL
		System.out.println("FIN DE PROCESAMIENTO");

		return res;
	} // de la Funcin
}