package jipfunc;

import jip.*;
import java.util.Vector;
import java.util.Random;

/**
* <P><FONT COLOR="red">
*<B>FSmoothAverage:</B> Realiza el suavizado de la imagen mediante la media<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Realiza el suavizado de la imagen mediante la media.<BR>
*Aplicable a tipos: BYTE, WORD, COLOR y REAL<BR>
*Usa: FConvolveImage.<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>radio: Radio de la ventana<BR>
*<li>bordes: ZERO-> los pixels que quedan fuera se ponen a 0.
*PAD->cuando el pixel est fuera, se toma el valor del pixel de la imagen
*ms cercano. P.e. (-1,-1) se tomara (0,0), (-2,2) se tomara (0,2), etc.
*WRAP-> cuando el pxel est fuera, se toma el valor del pixel opuesto en
*los ejes que corresponda. P.e. (-1,-1) se tomara (w,h), (0,-2) se tomara
*(0,h-1) etc.<BR><BR>
*</ul>
*<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen Procesada del mismo tipo que la imagen de entrada<BR><BR>
*</ul>
*/


public class FSmoothAverage extends JIPFunction {

     /**
      *<P><FONT COLOR="red">
      *Constructor de la Clase.<BR>
      *<P><FONT COLOR="blue">    
      *Obtiene los parmetros de entrada para aplicar la funcin.
      *<ul><B>Parametros de Entrada:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      *<ul><B>Parametros de Salida:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      */

    public FSmoothAverage() {
		//Nombre y descripcion de la Funcion
	    name="FSmoothAverage";
	    description="Suavizado (media)";

	  //Definicion de Parametros
		JIPParameter p1=new JIPParameter("radio",JIP.pINT,false);
		p1.setDefault(2);
		p1.setDescription("Radio");
    JIPParameter p2=new JIPParameter("bordes",JIP.pSTRING,false);
    p2.setDefault("ZERO");
    p2.setDescription("ZERO, WRAP, PAD");
		//Asignacion de Parametros
    params=new Vector();
		params.addElement(p1);
    params.addElement(p2);

    }

    /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *Se le llama para realizar el suavizado mediante
    *la media a la imagen de entrada.<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Imagen suavizada mediante la media.<BR><BR>
    *</ul>
    *Notas Adicionales: Los clculos no se realizan en esta
    *funcin, sino que se crea un objeto de FConvolveImage, y 
    *llama a esta funcin despus de crear una imagen con los
    *datos matemticos de entrada.
    */

    public JIPImage processImg(JIPImage img) 
     {
		  JIPImage res=null;
		  int radio=((JIPParameter)params.elementAt(0)).getValueInt();
		  String p2=getParamValueStr("bordes").toUpperCase();
    
		  JIPFunction convolucion=new FConvolveImage();
      float mat[]=new float[(radio*2+1)*(radio*2+1)];
      for (int a=0;a<(radio*2+1)*(radio*2+1);a++) mat[a]=(float)1.0;
      JIPImage convo=new JIPImage(radio*2+1,radio*2+1,mat);
    
      convolucion.setParamValue("imagen",convo);
      convolucion.setParamValue("div",(float)((radio*2+1)*(radio*2+1)));
      convolucion.setParamValue("metodo",p2);
    
      // LLamamos a FConvolve
      res=convolucion.processImg(img);
      return res;
	   }
}