package jipfunc;

import jip.*;
import java.util.Vector;
import java.util.Random;

/**
* <P><FONT COLOR="red">
*<B>FSmoothMedian:</B> Realiza el suavizado de la imagen mediante la mediana<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Realiza el suavizado de la imagen mediante la mediana.<BR>
*Aplicable a tipos: BYTE, WORD, COLOR y REAL<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>radio: Radio de la ventana<BR><BR>
*</ul>
*<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen Procesada del mismo tipo que la imagen de entrada<BR><BR>
*</ul>
*/


public class FSmoothMedian extends JIPFunction {

      /**
      *<P><FONT COLOR="red">
      *Constructor de la Clase.<BR>
      *<P><FONT COLOR="blue">    
      *Obtiene los parmetros de entrada para aplicar la funcin.
      *<ul><B>Parametros de Entrada:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      *<ul><B>Parametros de Salida:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      */


    public FSmoothMedian() {
		//Nombre y descripcion de la Funcion
	    name="FSmoothMedian";
	    description=
	         "Suavizado (mediana)";

	    //Definicion de Parametros
		JIPParameter p1=new JIPParameter("radio",JIP.pINT,false);
		p1.setDefault(2);
		p1.setDescription("Radio");

		//Asignacion de Parametros
        params=new Vector();
		params.addElement(p1);

    }
    
    /**
    *<P><FONT COLOR="red">
    *DESCRIPCIN<BR>
    *<P><FONT COLOR="blue">    
    *Calcula la mediana de los elementos de un vector
    *de tipo entero.<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>vector: Vector que contiene los elementos<BR>
    *<li>longitud: Longitud a tratar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Devuelve la mediana de los elementos de entrada (en el vector)<BR><BR>
    *</ul>
    */


public int Mediana(int vector[],int longitud)
  {
    int k=(int)(longitud/2);
    int izq=0; int der=longitud;
    int x=0,i,j,aux;
    while (izq<der)
      {
        x=vector[k]; i=izq; j=der;
        do
        {
          while (vector[i]<x) i++;
          while (x<vector[j]) j--;
          if (i<=j)
            {
              aux=vector[i];
              vector[i]=vector[j];
              vector[j]=aux;
              i++; j--;
            }
        }while(i<=j);
        if (j<k) izq=i;
        if (k<i) der=j;
      }
    return(x);
  }
    
    /**
    *<P><FONT COLOR="red">
    *DESCRIPCIN<BR>
    *<P><FONT COLOR="blue">    
    *Calcula la mediana de los elementos de un vector
    *de tipo float.<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>vector: Vector que contiene los elementos<BR>
    *<li>longitud: Longitud a tratar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Devuelve la mediana de los elementos de entrada (en el vector)<BR><BR>
    *</ul>
    */
    
    
public float Mediana(float vector[],int longitud)
  {
    int k=(int)(longitud/2);
    int izq=0; int der=longitud;
    float x=0,aux;
    int i,j;
    while (izq<der)
      {
        x=vector[k]; i=izq; j=der;
        do
        {
          while (vector[i]<x) i++;
          while (x<vector[j]) j--;
          if (i<=j)
            {
              aux=vector[i];
              vector[i]=vector[j];
              vector[j]=aux;
              i++; j--;
            }
        }while(i<=j);
        if (j<k) izq=i;
        if (k<i) der=j;
      }
    return(x);
  }
    
    /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *Se le llama para realizar el suavizado mediante
    *la media de la imagen de entrada.<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Imagen suavizada mediante la media.<BR><BR>
    *</ul>
    */

    
    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
		int p1=((JIPParameter)params.elementAt(0)).getValueInt();
		Random rnd=new Random();
    int t=img.getType();		
    int w=img.getWidth();
		int h=img.getHeight();
		int b=img.getNumBands();
		int max;
    if (t!=JIP.tREAL && t!=JIP.tBYTE && t!=JIP.tCOLOR && t!=JIP.tWORD) return null;

    res=new JIPImage(b,w,h,t);
    
		for(int nb=0;nb<b;nb++) 
      {
        if (t!=JIP.tREAL)
          {
            int[] bmp=img.getAllPixel(nb);
	    	    int[] bin=new int[w*h];
            int[] vector=new int[(p1+p1+1)*(p1+p1+1)];
		    	  for(int i=0; i<h; i++)
		    	    for(int j=0; j<w; j++)
			         {
			          int inicioX=j-p1, finX=j+p1;
			          int inicioY=i-p1, finY=i+p1;
			          if(inicioX<0) inicioX=0 ;  if(finX>=w) finX=w-1 ;
			          if(inicioY<0) inicioY=0 ;  if(finY>=h) finY=h-1 ;
			          float aux=0 ;
			          int cont=0;
			          for (int y=inicioY; y<=finY; y++)
			            for (int x=inicioX; x<=finX; cont++, x++)
				               vector[cont]=bmp[x+y*w];
                bin[j+i*w]=Mediana(vector,cont-1);
			         }
		    	res.setAllPixel(nb,bin);
		      }
        else
          {
            float[] bmp=img.getAllPixelFlo(nb);
            float[] bin=new float[w*h];
            float[] vector=new float[(p1+p1+1)*(p1+p1+1)];
            for(int i=0; i<h; i++)
              for(int j=0; j<w; j++)
               {
                int inicioX=j-p1, finX=j+p1;
                int inicioY=i-p1, finY=i+p1;
                if(inicioX<0) inicioX=0 ;  if(finX>=w) finX=w-1 ;
                if(inicioY<0) inicioY=0 ;  if(finY>=h) finY=h-1 ;
                float aux=0 ;
                int cont=0;
                for (int y=inicioY; y<=finY; y++)
                  for (int x=inicioX; x<=finX; cont++, x++)
                       vector[cont]=bmp[x+y*w];
                bin[j+i*w]=Mediana(vector,cont-1);
               }
          res.setAllPixel(nb,bin);
          }

		  }
	
		return res;
	}
}