package jipfunc;

import jip.*;
import java.util.Vector;

/**
* <P><FONT COLOR="red">
*<B>FUser3x3:</B> Aplica una convolucion con 
*la mascara dada (de tamao 3x3)<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Aplica una convolucion con la mascara dada (de tamao 3x3).<BR>
*Aplicable a tipos: BYTE, WORD, COLOR y REAL<BR>
*Usa: FConvolveImage.<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>matriz: elementos correspondientes a la matriz de convolucin.<BR>
*<li>mul: Multiplicador<BR>
*<li>div: Divisor<BR>
*<li>bordes: ZERO-> los pixels que quedan fuera se ponen a 0.
*PAD->cuando el pixel est fuera, se toma el valor del pixel de la imagen
*ms cercano. P.e. (-1,-1) se tomara (0,0), (-2,2) se tomara (0,2), etc.
*WRAP-> cuando el pxel est fuera, se toma el valor del pixel opuesto en
*los ejes que corresponda. P.e. (-1,-1) se tomara (w,h), (0,-2) se tomara
*(0,h-1) etc.<BR><BR>
*</ul>
*<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen Procesada del mismo tipo que la imagen de entrada<BR><BR>
*</ul>
*/


public class FUser3x3 extends JIPFunction {
  
      /**
      *<P><FONT COLOR="red">
      *Constructor de la Clase.<BR>
      *<P><FONT COLOR="blue">    
      *Obtiene los parmetros de entrada para aplicar la funcin.
      *<ul><B>Parametros de Entrada:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      *<ul><B>Parametros de Salida:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      */


 public FUser3x3() {
	//Nombre y descripcion de la Funcion
	name="FUser3x3";
	description="Aplica una convolucion con la mascara dada (de tamao 3x3)";

    //Definicion de Parametros
	JIPParameter p1 =new JIPParameter("a1",JIP.pREAL,false); p1.setDefault((float)0);p1.setDescription("");
	JIPParameter p2 =new JIPParameter("a2",JIP.pREAL,false); p2.setDefault((float)0);p2.setDescription("");
	JIPParameter p3 =new JIPParameter("a3",JIP.pREAL,false); p3.setDefault((float)0);p3.setDescription("");
	JIPParameter p4 =new JIPParameter("b1",JIP.pREAL,false); p4.setDefault((float)0);p4.setDescription("");
	JIPParameter p5 =new JIPParameter("b2",JIP.pREAL,false); p5.setDefault((float)1);p5.setDescription("");
	JIPParameter p6 =new JIPParameter("b3",JIP.pREAL,false); p6.setDefault((float)0);p6.setDescription("");
	JIPParameter p7 =new JIPParameter("c1",JIP.pREAL,false); p7.setDefault((float)0);p7.setDescription("");
	JIPParameter p8 =new JIPParameter("c2",JIP.pREAL,false); p8.setDefault((float)0);p8.setDescription("");
	JIPParameter p9 =new JIPParameter("c3",JIP.pREAL,false); p9.setDefault((float)0);p9.setDescription("");
	JIPParameter p10=new JIPParameter("mul",JIP.pREAL,false); p10.setDefault((float)1);p10.setDescription("Multiplicador ");
	JIPParameter p11=new JIPParameter("div",JIP.pREAL,false); p11.setDefault((float)1);p11.setDescription("Divisor       ");
  JIPParameter p12=new JIPParameter("metodo",JIP.pSTRING,false);
  p12.setDefault("ZERO");
  p12.setDescription("ZERO, WRAP, PAD");

		//Asignacion de Parametros
        params=new Vector();
	params.addElement(p1); params.addElement(p2); params.addElement(p3);
	params.addElement(p4); params.addElement(p5); params.addElement(p6);
	params.addElement(p7); params.addElement(p8); params.addElement(p9);
	params.addElement(p10);params.addElement(p11);params.addElement(p12);
 }
    
    /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *Se le llama para realizar el montaje de la matriz, 
    *crear una imagen con esa matriz y desde aqui llamar
    *a FConvolveImage que es donde se realiza realmente la
    *convolucin.<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Imagen convolucionada con la matriz introduzida por
    *el usuario.<BR><BR>
    *</ul>
    *Notas Adicionales: Los clculos no se realizan en esta
    *funcin, sino que se crea un objeto de FConvolveImage, y 
    *llama a esta funcin despus de crear una imagen con los
    *datos matemticos de entrada.
    */

    
    public JIPImage processImg(JIPImage img) {
		JIPImage res=null;
    float mat[]=new float[9];
		mat[0]= ((JIPParameter)params.elementAt(0)).getValueReal();
		mat[1]= ((JIPParameter)params.elementAt(1)).getValueReal();
		mat[2]= ((JIPParameter)params.elementAt(2)).getValueReal();
		mat[3]= ((JIPParameter)params.elementAt(3)).getValueReal();
		mat[4]= ((JIPParameter)params.elementAt(4)).getValueReal();
		mat[5]= ((JIPParameter)params.elementAt(5)).getValueReal();
		mat[6]= ((JIPParameter)params.elementAt(6)).getValueReal();
		mat[7]= ((JIPParameter)params.elementAt(7)).getValueReal();
		mat[8]= ((JIPParameter)params.elementAt(8)).getValueReal();
		float mult=((JIPParameter)params.elementAt(9)).getValueReal();
		float div=((JIPParameter)params.elementAt(10)).getValueReal();
    String metodo=getParamValueStr("metodo").toUpperCase();

    
    JIPFunction convolucion=new FConvolveImage();
      
    JIPImage convo=new JIPImage(3,3,mat);
    
    convolucion.setParamValue("imagen",convo);
    convolucion.setParamValue("div",div);
    convolucion.setParamValue("mult",mult);
    convolucion.setParamValue("metodo",metodo);
    
      // LLamamos a FConvolve
    res=convolucion.processImg(img);

  return res;
 }
}
	