package jipfunc;

import jip.*;
import java.util.Vector;

/**
* <P><FONT COLOR="red">
*<B>FUser5x5:</B> Aplica una convolucion con 
*la mascara dada (de tamao 5x5)<BR>
*<FONT COLOR="blue">
*DESCRIPCION: Aplica una convolucion con la mascara dada (de tamao 5x5).<BR>
*Aplicable a tipos: BYTE, WORD, COLOR y REAL<BR>
*Usa: FConvolveImage.<BR>
*<ul><B>Parametros de Entrada:</B><BR>
*<li>img: Imagen de Entrada<BR>
*<li>matriz: elementos correspondientes a la matriz de convolucin.<BR>
*<li>mul: Multiplicador<BR>
*<li>div: Divisor<BR>
*<li>bordes: ZERO-> los pixels que quedan fuera se ponen a 0.
*PAD->cuando el pixel est fuera, se toma el valor del pixel de la imagen
*ms cercano. P.e. (-1,-1) se tomara (0,0), (-2,2) se tomara (0,2), etc.
*WRAP-> cuando el pxel est fuera, se toma el valor del pixel opuesto en
*los ejes que corresponda. P.e. (-1,-1) se tomara (w,h), (0,-2) se tomara
*(0,h-1) etc.<BR><BR>
*</ul>
*<ul><B>Parametros de Salida:</B><BR>
*<li>Imagen Procesada del mismo tipo que la imagen de entrada<BR><BR>
*</ul>
*/


public class FUser5x5 extends JIPFunction {

      /**
      *<P><FONT COLOR="red">
      *Constructor de la Clase.<BR>
      *<P><FONT COLOR="blue">    
      *Obtiene los parmetros de entrada para aplicar la funcin.
      *<ul><B>Parametros de Entrada:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      *<ul><B>Parametros de Salida:</B><BR>
      *<li>NINGUNO<BR><BR>
      *</ul>
      */


 public FUser5x5() 
   {
	  //Nombre y descripcion de la Funcion
	  name="FUser5x5";
	  description="Aplica una convolucion con la mascara dada (de tamao 5x5)";

    //Definicion de Parametros
	  params=new Vector();
	  JIPParameter p[]=new JIPParameter[27];
	  for (int i=0;i<27;i++)
      {
     	 p[i]=new JIPParameter("p"+i,JIP.pREAL,false);
		   if (i!=12 && i!=25 && i!=26) p[i].setDefault((float)0);
		   else p[i].setDefault((float)1);
		   p[i].setDescription("");
		   params.addElement(p[i]);
      }
    JIPParameter metodo=new JIPParameter("metodo",JIP.pSTRING,false);
    metodo.setDefault("ZERO");
    params.addElement(metodo);
  }
    
    /**
    *<P><FONT COLOR="red">
    *Mtodo Principal<BR>
    *<P><FONT COLOR="blue">    
    *Se le llama para realizar el montaje de la matriz, 
    *crear una imagen con esa matriz y desde aqui llamar
    *a FConvolveImage que es donde se realiza realmente la
    *convolucin.<BR>
    *<ul><B>Parametros de Entrada:</B><BR>
    *<li>img: Imagen a procesar<BR><BR>
    *</ul>
    *<ul><B>Parametros de Salida:</B><BR>
    *<li>Imagen convolucionada con la matriz introduzida por
    *el usuario.<BR><BR>
    *</ul>
    *Notas Adicionales: Los clculos no se realizan en esta
    *funcin, sino que se crea un objeto de FConvolveImage, y 
    *llama a esta funcin despus de crear una imagen con los
    *datos matemticos de entrada.
    */

    
 public JIPImage processImg(JIPImage img) 
   {
		JIPImage res=null;
		float[] mat=new float[25];
		for (int i=0;i<25;i++) 
 			mat[i]=((JIPParameter)params.elementAt(i)).getValueReal();
		float mul=((JIPParameter)params.elementAt(25)).getValueReal();
		float div=((JIPParameter)params.elementAt(26)).getValueReal();
    String metodo=getParamValueStr("metodo").toUpperCase();
    
    JIPFunction convolucion=new FConvolveImage();
      
    JIPImage convo=new JIPImage(5,5,mat);
    
    convolucion.setParamValue("imagen",convo);
    convolucion.setParamValue("div",div);
    convolucion.setParamValue("mult",mul);
    convolucion.setParamValue("metodo",metodo);
    
    // LLamamos a FConvolve
    res=convolucion.processImg(img);
 
		return res;
	}
}