package jiputil;

import jip.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Clase empleada para la creacin de los cuadros de dilogo de las funciones aplicables.
  *Desde aqui se crean todos los botones y textos de entrada para captar la entrada
  *del usuario.
  */


public class JIPFunctionDialogG extends JDialog {

	/** Nos dice si se ha pulsado OK */
	boolean confirmed;
	/** Nos dice si se han asignado los valores */
	boolean ok=false;
	/** Indica el nmero de parmetros*/
	int nparam;
	/** Nombres de los parmetros */
	String[] pnames=null;
	/** Valores de texto */
	JTextField[] values=null;
	/** CheckBox */
	CheckboxGroup cbg=null;
	/** Funcion desde la que nos llaman*/
	JIPFunction func=null;
	
	
	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Constructor de la clase. Asigna la funcin, y el nombre en la barra de arriba
   * @param frame JFrame desde donde se nos llama. Se utiliza para centrar la ventana.
   * @param function Funcin que vamos a aplicar
   */
	public JIPFunctionDialogG(JFrame frame,JIPFunction function) {
		super(frame,"Funcin: "+function.getName(),true);
	  	confirmed=false;
		func=function;
		
		//Obtenemos informacion de la funcion
		nparam=func.getNumParams();
		pnames=func.getParamNames();
		String[] pdescr=null;
		if(nparam>0) {
			pdescr=new String[nparam];
			values=new JTextField[nparam];
		}
		
		for(int i=0;i<nparam;i++) {
			String param=pnames[i];
			pdescr[i]=func.getParamDescr(param);
			if (function.getName().compareTo("FUser5x5")==0 ||
          function.getName().compareTo("FUser3x3")==0)
        values[i]=new JTextField("",4);
      else values[i]=new JTextField("",15);

      
			if(!func.isParamRequired(param)) {
				switch(func.getParamType(param)) {
				case JIP.pBOOL:
					values[i].setText(String.valueOf(func.getParamValueBool(param))); break;
				case JIP.pINT:
					values[i].setText(String.valueOf(func.getParamValueInt(param))); break;
				case JIP.pREAL:
					values[i].setText(String.valueOf(func.getParamValueReal(param))); break;
				case JIP.pSTRING:
					values[i].setText(func.getParamValueStr(param)); break;
				case JIP.pIMAGE:
					values[i].setText(""); break;
				}
			}
		}

		// Panel de los parametros
		JPanel pparams=new JPanel();
    if (function.getName().compareTo("FUser3x3")==0)
      { pparams.setLayout(new GridLayout(6,1)); }
    else       
       { 
        if (function.getName().compareTo("FUser5x5")==0)
           { pparams.setLayout(new GridLayout(8,1)); } 
        else
           { if(nparam>0) pparams.setLayout(new GridLayout(nparam*2,1)); }
       }

    if (function.getName().compareTo("FUser3x3")==0)
       {
      for (int i=0;i<9;i+=3)
        {
           JPanel fila=new JPanel();
         fila.add("East",values[i]);
         fila.add("East",values[i+1]);
         fila.add("East",values[i+2]);
         pparams.add(fila);
        }
       JPanel mul=new JPanel(); mul.add("West",new JLabel("Multiplicador")); mul.add(values[9]);
       JPanel div=new JPanel(); div.add("West",new JLabel("Divisor      ")); div.add(values[10]);
       JPanel metodo=new JPanel(); metodo.add("West",new JLabel("Metodo: ZERO,WRAP,PAD"));metodo.add(values[11]);
      pparams.add(mul); pparams.add(div);
      pparams.add(metodo);
       }
    else
       {
         if (function.getName().compareTo("FUser5x5")==0)
          {
           for (int i=0;i<25;i+=5)
            {
             JPanel fila=new JPanel();
             fila.add("East",values[i]);
             fila.add("East",values[i+1]);
             fila.add("East",values[i+2]);
             fila.add("East",values[i+3]);
             fila.add("East",values[i+4]);
             pparams.add(fila);
            }
           JPanel mul=new JPanel(); mul.add("West",new JLabel("Multiplicador")); mul.add(values[25]);
           JPanel div=new JPanel(); div.add("West",new JLabel("Divisor      ")); div.add(values[26]);
           JPanel metodo=new JPanel(); metodo.add("West",new JLabel("ZERO,WRAP,PAD")); metodo.add(values[27]);
           pparams.add(mul); pparams.add(div);
           pparams.add(metodo);
          }
         else
		      for(int i=0;i<nparam;i++) {
			     JPanel aux=new JPanel();
			     if(func.isParamRequired(pnames[i]))
			 	     aux.add("West",new JLabel("[REQUERIDO] "+pnames[i]+":"));
			     else
				    aux.add("West",new JLabel(pnames[i]+":"));
			      aux.add("East",values[i]);
			      pparams.add(new JLabel(pdescr[i]));
			      pparams.add(aux);
		       }
       }		
		// Panel de los botones
		MyActionListener al=new MyActionListener();
		JButton bt0=new JButton("OK");
		bt0.addActionListener(al);
		JButton bt1=new JButton("Cancelar");
		bt1.addActionListener(al);		
		JPanel pbot=new JPanel();
		pbot.add("West",bt0);
		pbot.add("East",bt1);		
		
		// Panel del checkbox
		cbg=new CheckboxGroup();
		JPanel pcheck=new JPanel(new GridLayout(3,1));
		
		pcheck.add(new JLabel("Aplicar a:"));
		pcheck.add(new Checkbox(" Toda la secuencia",cbg,false));
		pcheck.add(new Checkbox(" Frame seleccionado",cbg,true));
		
		// Panel Botones+Check
		JPanel pbotcheck=new JPanel();
		pbotcheck.add("West",pcheck);
		pbotcheck.add("East",pbot);
		
		getContentPane().add("North",new JLabel(func.getDescription()));
		getContentPane().add("Center",pparams);
		getContentPane().add("South",pbotcheck);		
		getContentPane().setBackground(new Color(232,232,232));
		pack();
		center(frame);			
	}	

	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Indica si se ha pulsado el botn de OK
   * @return TRUE si se ha pulsado. FALSE si no se ha pulsado
   */

	
	public boolean isConfirmed() { return confirmed; }	
	
	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Indica si se ha pulsado el botn de Cancel
   * @return TRUE si se ha pulsado. FALSE si no se ha pulsado
   */
   
	public boolean isCancelled() { return !confirmed; }

	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Indica si se han asignado los parmetros
   * @return TRUE si se han asignado. FALSE si no se han asignado
   */
	public boolean isAssignedOK() { return ok; }
	
	
	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Indica si el checkbox tiene "Toda la secuencia" activo
   * @return TRUE si est seleccionado "Toda la secuencia".
   * FALSE si est seleccionado "Frame seleccionado"
   */
	public boolean applyToSeq() {
		return (cbg.getSelectedCheckbox().getLabel().compareTo(" Toda la secuencia")==0);
	}
	
	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Indica si el checkbox tiene "Frame seleccionado" activo
   * @return TRUE si est seleccionado "Frame seleccionado".
   * FALSE si est seleccionado "Toda la secuencia"
   */
	public boolean applyToFrame() {
		return (cbg.getSelectedCheckbox().getLabel().compareTo(" Frame seleccionado")==0);
	}
		
	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Centra la ventana a la mitad de la ventana desde la que se llam
   * @param frame JFrame al cual nos queremos centrar.
   */
	
  void center(JFrame frame) {
		Point p=frame.getLocationOnScreen();
		Dimension dframe=frame.getSize();
		Dimension dthis=getSize();
		int x=(dframe.width-dthis.width)/2;
		int y=(dframe.height-dthis.height)/2;
		if(x<0) x=0; if(y<0) y=0;
		setLocation(p.x+x,p.y+y);
    }

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Asigna los valores de los parmetros a la funcin
   */


    void assignValues() {
    	ok=true;
    	for(int i=0;i<nparam && ok;i++) {
			String param=pnames[i];
			String value=values[i].getText().trim();
			switch(func.getParamType(param)) {
			case JIP.pBOOL:
				if(value.toUpperCase().compareTo("TRUE")==0) func.setParamValue(param,true);
				else if(value.toUpperCase().compareTo("FALSE")==0) func.setParamValue(param,false);
				else ok=false;				
				break;
			case JIP.pINT:
				try { func.setParamValue(param,Integer.valueOf(value).intValue());
				} catch (NumberFormatException e) { ok=false; }
				break;
			case JIP.pREAL:
				try { func.setParamValue(param,Float.valueOf(value).floatValue());
				} catch (NumberFormatException e) { ok=false; }
				break;
			case JIP.pSTRING:
				func.setParamValue(param,value);
				break;				
			case JIP.pIMAGE:
                JIPSequence auxseq=JIPToolkit.getSeqFromFile(value);
                if(auxseq!=null)
					func.setParamValue(param,auxseq.getFrame(0));
				else ok=false;
				break;
			}    		
    	}
    	if(!func.paramsOK()) ok=false;
    }

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Implementa el ActionListener del Ratn sobre el botn de OK
   */

    class MyActionListener implements ActionListener {
	    public void actionPerformed(ActionEvent e) {
	        String cmd=e.getActionCommand();
	        if(cmd.compareTo("OK")==0) {
	        	confirmed=true;
	        	assignValues();
	        }
	        else confirmed=false;
	    	setVisible(false);
	    }
	}
	
}