package jiputil;

import jip.*;
import jipfunc.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import javax.swing.*;

/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * 		Clase que implementa contiene la lista de funciones aplicables desde el programa.
   *Es en sta clase donde se espeficican las funciones y a que grupo pertenece cada una.
   */


public class JIPFunctionList {

	/** Nmero de funciones en lista */
	int nfunc;
	/** Nmero de grupos creados */
	int ngrps;
	/** Array que contiene los nombres de las funciones */
	String[] funcnames=null;
	/** Array que contiene los nombres de los grupos */
	String[] groupnames=null;
	/** Array que asocia las funciones con los grupos */
	int[] funcgroups=null;
		
	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 *		Constructor de la clase. Aqui se insertan los nombres de las funciones aplicables en
	 *los respectivos arrays, as como los grupos a los que pertenecen cada una.
	 */	
	public JIPFunctionList() {
		
		// Grupos de funciones disponibles
		ngrps=10;
		groupnames=new String[ngrps];
		groupnames[0]="Conversin";
		groupnames[1]="Ajustes";
    groupnames[2]="Suavizado";
    groupnames[3]="Realce";
    groupnames[4]="Convolucion";
		groupnames[5]="Manipulacin";
    groupnames[6]="Geometra";
    groupnames[7]="Contorno";
    groupnames[8]="Gradiente";
    groupnames[9]="Otras...";


		// Funciones disponibles: especificar el nombre de la clase y el indice del grupo
		// (-1 para funciones sin grupo asignado)
		
    
    funcnames=new String[128];
		funcgroups=new int[128];
		
    int cont=-1;

        
    // conversion
    funcnames[++cont] ="FColorToGray";  funcgroups[cont] =0;
    funcnames[++cont] ="FGrayToGray";   funcgroups[cont] =0;
    
    // ajustes
    funcnames[++cont] ="FBrightness";   funcgroups[cont] =1;
    funcnames[++cont] ="FContrast";     funcgroups[cont] =1;
    funcnames[++cont] ="FGamma";     funcgroups[cont] =1;
    funcnames[++cont] ="FEqualize";     funcgroups[cont] =1;

    // suavizado
    funcnames[++cont] ="FSmoothAverage"; funcgroups[cont] =2;
    funcnames[++cont] ="FSmoothMedian";  funcgroups[cont] =2;
    funcnames[++cont] ="FSmoothGaussian";funcgroups[cont] =2;
    funcnames[++cont] ="FSmoothRadial";  funcgroups[cont] =2;
    
    // realce
    funcnames[++cont] ="FSharpen";       funcgroups[cont] =3;
    funcnames[++cont] ="FSharpenMore";   funcgroups[cont] =3;
    
    // convolucion
    funcnames[++cont]="FUser3x3";       funcgroups[cont] =4;
    funcnames[++cont]="FUser5x5";       funcgroups[cont] =4;
    funcnames[++cont]="FConvolveImage"; funcgroups[cont] =4;
    funcnames[++cont]="FConvolveAscii"; funcgroups[cont] =4;

    // manipulacion
    funcnames[++cont] ="FSkew";    		   funcgroups[cont] =5;
    funcnames[++cont] ="FFlip";          funcgroups[cont] =5;
    funcnames[++cont] ="FMirror";        funcgroups[cont] =5;
    funcnames[++cont] ="FScale";         funcgroups[cont] =5;
    funcnames[++cont] ="FRotate";        funcgroups[cont] =5;
    funcnames[++cont] ="FWaveHoriz";     funcgroups[cont] =5;
    funcnames[++cont] ="FWaveVert";      funcgroups[cont] =5;
    funcnames[++cont] ="FNegate";        funcgroups[cont] =5;
    funcnames[++cont] ="FNoise";         funcgroups[cont] =5;



    // geometria
    funcnames[++cont] ="FAddPoint";      funcgroups[cont] =6;
    funcnames[++cont] ="FAddSegment";    funcgroups[cont] =6;
    funcnames[++cont] ="FRandomPoint";   funcgroups[cont] =6;
    funcnames[++cont] ="FRandomSegment"; funcgroups[cont] =6;
    funcnames[++cont] ="FInterSegment";  funcgroups[cont] =6;
    funcnames[++cont] ="FGeoToGray";     funcgroups[cont] =6;

    
    // Contorno
    funcnames[++cont] ="FCanny";         funcgroups[cont] =7;
    funcnames[++cont] ="FLink";          funcgroups[cont] =7;
    funcnames[++cont] ="FSegEdges";      funcgroups[cont] =7;
    
    // Gradiente
    funcnames[++cont] ="FGrad";          funcgroups[cont] =8;
    funcnames[++cont] ="FMag";           funcgroups[cont] =8;
    funcnames[++cont] ="FPhase";         funcgroups[cont] =8;
    
    // otras...
    funcnames[++cont] ="FHistogram";     funcgroups[cont] =9;
    funcnames[++cont] ="FSkeleton";      funcgroups[cont] =9;
    funcnames[++cont] ="FBinarize";      funcgroups[cont] =9;
    funcnames[++cont] ="FCrop";          funcgroups[cont] =9;
    funcnames[++cont] ="FMaximum";       funcgroups[cont] =9;
    funcnames[++cont] ="FMinimum";       funcgroups[cont] =9;
    funcnames[++cont] ="FPixelate";      funcgroups[cont] =9;
    funcnames[++cont] ="FOp";            funcgroups[cont] =9;

    nfunc=cont+1; 
	}

	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Mtodo para obtener el nmero de funciones que hay creadas.
   * @return Nmero de Funciones
   */

	public int getNumFunctions() { return nfunc; }
	
	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Mtodo para obtener el nombre del nmero de funcin que se pasa por
   *parmetro.
   * @param f Nmero asignado a una funcin
   * @return Nombre de la funcin pedida
   */
	
	
	public String getName(int f) {
		if(f>=0&&f<nfunc) return funcnames[f];
		else return new String("");
	}

	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Mtodo para obtener el objeto funcin del cual sabemos el nombre y pasamos
   *por parmetro
   * @param fname Nombre de la funcin
   * @return Objeto JIPFuncion que contiene la funcion pedida
   */
	
	public JIPFunction getJIPFunction(String fname) {
		JIPFunction func=null;
		for(int i=0;i<nfunc;i++) {
			if(fname.compareTo(funcnames[i])==0) {
				Object objeto=null;
				try {
					Class clase=Class.forName("jipfunc."+fname);
					objeto=clase.newInstance();
				} catch(Exception e) { System.err.println(e); }
				if(objeto!=null) func=(JIPFunction)objeto;
				break;
			}
		}
		return func;
	}
	
	
	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Mtodo para crear el men que contiene las funciones
   * @param tittle Ttulo del men
   * @param al ActionListener
   * @return Men que contiene las funciones
   */
			
	public Menu getFunctionMenu(String tittle,ActionListener al) {
		Menu mfunc=new Menu(tittle);
		MenuItem item;
		Menu m;
		
		// Insertamos grupos de funciones y sus funciones
		for(int i=0;i<ngrps;i++) {
			m=new Menu(groupnames[i]);
			for(int j=0;j<nfunc;j++) {
				if(funcgroups[j]==i) {
					item=new MenuItem(funcnames[j]);
					item.setActionCommand("F_"+funcnames[j]);
					item.addActionListener(al);
					m.add(item);
				}
			}
			mfunc.add(m);
		}		

    // Insertamos funciones sin grupo asignado
    for(int i=0;i<nfunc;i++) {
      if(funcgroups[i]==-1) {
        item=new MenuItem(funcnames[i]);
        item.setActionCommand("F_"+funcnames[i]);
        item.addActionListener(al);
        mfunc.add(item);
      }
    }
    return mfunc;
  }
	
  public JMenu getFunctionMenuG(String tittle,ActionListener al) {
    JMenu mfunc=new JMenu(tittle);
    JMenuItem item;
    JMenu m;
    
    // Insertamos grupos de funciones y sus funciones
    for(int i=0;i<ngrps;i++) {
      m=new JMenu(groupnames[i]);
      for(int j=0;j<nfunc;j++) {
        if(funcgroups[j]==i) {
          item=new JMenuItem(funcnames[j]);
          item.setActionCommand("F_"+funcnames[j]);
          item.addActionListener(al);
          m.add(item);
        }
      }
      mfunc.add(m);
    }    
  
  
		// Insertamos funciones sin grupo asignado
		for(int i=0;i<nfunc;i++) {
			if(funcgroups[i]==-1) {
				item=new JMenuItem(funcnames[i]);
				item.setActionCommand("F_"+funcnames[i]);
				item.addActionListener(al);
				mfunc.add(item);
			}
		}
		return mfunc;
	}

}