
import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 *   Realiza un filtro de extensiones para los cuadros de dialogo de abrir y cerrar
	 *ficheros desde el entorno grfico del programa. En esta clase se realizan
	 *los filtros para obtener solo jpeg,jpg y gif.
	 * @author THE BOINA
   */



public class ALLImageFilter extends FileFilter
{
   /** Cadena de texto para jpeg*/	
   final static String jpeg = "jpeg";
   /** Cadena de texto para jpg*/	
   final static String jpg  = "jpg";
   /** Cadena de texto para gif*/	
   final static String gif  = "gif";

   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *  Indica si se acepta el fichero, es decir, si es un directorio, o su extensin es
   * jpeg, jpg o gif, devolver TRUE.
   * @param f Fichero a analizar
   * @return TRUE si el fichero es un directorio o su extension es jpeg, jpg o gif. FALSE
   * en otro caso.
   */

   public boolean accept (File f)
   {
      if (f.isDirectory())
      {
         return true;
      }

      String s = f.getName();
      int    i = s.lastIndexOf('.');

      if ((i > 0) && (i < s.length() - 1))
      {
         String extension = s.substring(i + 1).toLowerCase();

         if (gif.equals(extension) || jpeg.equals(extension)
                 || jpg.equals(extension))
         {
            return true;
         }
         else
         {
            return false;
         }
      }

      return false;
   }

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 * Descripcion del filtro
	 * @return Devuelve una cadena con la descripcin del filtro.
	 */
   
   public String getDescription ()
   {
      return "Images Compatibles (gif,jpg,jpeg)";
   }
}