import javax.swing.*;  
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.io.*;
import jip.*;
import InfoPanel;

/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 * Clase que contiene la secuencia activa del programa as como los vectores que contienen los
	 * valores geomtricos de la geometra que se haya dibujado y todava no se haya pasado a un
	 * frame. Tambien contiene los flags que indican que cosas hay que repintar, resaltar, as como
	 * el panel de informacin de los datos que estamos tratando.
   */
public class CanvasGeo extends JPanel implements ActionListener 
 {
 	 /** Vector que contiene los valores de los Segmentos dibujados que an no han sido
 	 *pasados a un frame */
 	 Vector Segmentos;
 	 /** Vector que contiene los valores de los Puntos dibujados que an no han sido
 	 *pasados a un frame */
   Vector Puntos;
   /** Vector que contiene los valores de los Poligonos dibujados que an no han sido
 	 *pasados a un frame */
   Vector Poligonos;
   /** Vector que contiene los valores de los Edges dibujados que an no han sido
 	 *pasados a un frame */
   Vector Edges;
   /** Vector que contiene el histrico de los factores de escala */
   Vector factoresEscalas;
   /** Vector que con tiene los elementos que se estn visualizando */
   Vector visualizando;
   /** Indice de Segmentos */
   int indiceSeg=0;
   /** Indice de Puntos */
   int indicePunto=0;
   /** Indice de Poligonos */
   int indicePoly=0;
   /** Indice de Edges */
   int indiceEdge=0;
   /** Secuencia activa en el programa */
   JIPSequence secuencia;
   /** Ancho */
   int w=400;
   /** Alto */
   int h=300;
   /** Factor de Escala */
   int factorEscala=100;
   /** Flag que indica si la geometra est activada o no */
   int estadoGeo=1;
   /** Ancho Original*/
   int worg;
   /** Alto Original */
   int horg;
   /** Flag que indica si se est arrastrando con el ratn */
   boolean arrastrando;
   /** Flag que indica si hay que resaltar los Segmentos */
   boolean resaltaSegmentos;
   /** Flag que indica si hay que resaltar los Puntos */
   boolean resaltaPuntos;
   /** Flag que indica si hay que resaltar los Poligonos */
   boolean resaltaPoligonos;
   /** Flag que indica si hay que resaltar los Edges */
   boolean resaltaEdges;
   /** Flag que indica si se debe mostrar el Bitmap de fondo*/
   boolean verBitmap;
   /** Flag que indica si se deben mostrar los Segmentos */
   boolean verSegmentos;
   /** Flag que indica si se deben mostrar los Puntos */
   boolean verPuntos;
   /** Flag que indica si se deben mostrar los Poligonos */
   boolean verPoligonos;
   /** Flag que indica si se deben mostrar los Edges */
   boolean verEdges;
   /** Posicion x Inicial */
   int xini;
   /** Posicion y Inicial */
   int yini;
   /** Posicion x Final */
   int xfin;
   /** Posicin y Final */
   int yfin;
   /* Variable auxiliar */
   int num=0;
   /** Panel de Informacin */
   InfoPanel info;
   /** Mximo nmero de segmentos */
   int maxSeg=(1000*4);
   /** Componente */
   Component zona;
   /** Imagen de fondo */
   ImageIcon backGround;
   /** Color de Fondo */
   Color colorFondo;
   /** Color de fondo de panel de scroll */
   Color colorFondoScroll;
   /** Color de las lineas */
   Color colorLinea;
   /** Color de la lnea actual */
   Color colorLineaActual;
   /** Color de los puntos */
   Color colorPunto;
   /** Color de los polgonos */
   Color colorPoligono;
   /** Color del polgono actual */
   Color colorPoligonoActual;
   /** Color de los Edges */
   Color colorEdges;
   /** Vector que contiene al polgono actual */
   Vector PoligonoActual;
   /** Indica si estamos tratando puntos, segmentos o polgonos */
   int modo;
   /** Constante que indica que estamos tratando segmentos */
   int SEG=0;
   /** Constante que indica que estamos tratando puntos */
   int PUNTO=1;
   /** Constante que indica que estamos tratando polgonos */
   int POLY=2;
   /** Ultima posicin X*/
   int ultimoX=-1;
   /** Ultima posicin Y*/
   int ultimoY=-1;
   /** Indica el frame actual de la secuencia */
   int frame;
   /** Indica la banda actual del frame actual */
   int banda;
   /** Indica si estamos seleccionando o aadiendo */
   int accion;
   /** Variable auxiliar para seleccin */
   int x0Sel=-1;
   /** Variable auxiliar para seleccin */
   int y0Sel=-1;
   /** Variable auxiliar para seleccin */
   int x1Sel=-1;
   /** Variable auxiliar para seleccin */
   int y1Sel=-1;
   /** Variable auxiliar para seleccin */
   int idxPolySel=-1;
   /** Indica si estamos seleccionando puntos, segmentos o polgonos */
   int tipoSel;
   /** Variable de tipo imagen Auxiliar */
   JIPImage imgtmp;
   
   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Constructor de la clase. Se inicializan los vectores y variables
   * de clase.
   * @param ww Ancho del Canvas
   * @param hh Alto del Canvas
   */

   
   public CanvasGeo(int ww,int hh)
   {
    w=ww;
    h=hh;
    Segmentos=new Vector();
    Puntos=new Vector();
    Poligonos=new Vector();
    Edges=new Vector();
    PoligonoActual=new Vector();
    imgtmp=null;
    
    // vector historico de factores de escala aplicados 
    factoresEscalas=new Vector();
    visualizando=new Vector();
    estadoGeo=1;
    
    zona=new Box(BoxLayout.Y_AXIS).createRigidArea(new Dimension(w,h));
    add(zona);
    MyMouseListener mml=new MyMouseListener();
    addMouseListener(mml);
    addMouseMotionListener(mml);
    colorLinea=new Color(255,255,255);
    colorLineaActual=new Color(255,255,0);
    colorFondo=new Color(0,0,0);
    colorPunto=new Color(128,128,255);
    colorPoligono=new Color(255,128,128);
    colorPoligonoActual=new Color(128,255,128);
    colorFondoScroll = new Color(63,63,63);
    colorEdges=new Color(255,63,255);
    resaltaSegmentos=false;
    resaltaPuntos=true;
    resaltaPoligonos=false;
    resaltaEdges=true;
    verBitmap=verSegmentos=verPuntos=verPoligonos=verEdges=true;
    setBackground(colorFondoScroll);
   }
   
  /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Asocia el panel de informacin al de la clase
   * @param i Panel de Informacin
   */
 
  public void AsociaInfo(InfoPanel i) {info=i;}
  
  /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Crea un nuevo bitmap para empezar a crear una nueva secuencia bien
   *pintando o bien aadiendo nuevas imgenes
   * @param ww Ancho
   * @param hh Alto
   * @param bg Imagen de BackGround
   */

  public void Nuevo(int ww,int hh,ImageIcon bg)
   {
        
    factorEscala=100;
    factoresEscalas.removeAllElements();
    estadoGeo=1;
    num=0;
    w=ww;h=hh;
    remove(zona);
    zona=new Box(BoxLayout.Y_AXIS).createRigidArea(new Dimension(w,h));
    add(zona);
    backGround=bg;
    
    if (secuencia==null) { info.AsociaSecuencia(null); }
    x0Sel=y0Sel=x1Sel=y1Sel=-1;
    getParent().repaint();

   }
  /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *  Aade un nuevo segmento al vector de segmentos.
   * @param x0 Coordenada x inicial del segmento
   * @param y0 Coordenada y inicial del segmento
   * @param x1 Coordenada x final del segmento
   * @param y1 Coordenada y final del segmento
   */

  public void addSegment(int x0,int y0,int x1,int y1)
   {
    if (!(x0>=00 && x0<w && y0>=0 && y0<h &&
        x1>=00 && x1<w && y1>=0 && y1<h &&
        (x0!=x1 || y0!=y1))) return;
    for (int i=0;i<Segmentos.size();i+=4)
     {
      int x00=((Integer)Segmentos.elementAt(i)).intValue();
      int y00=((Integer)Segmentos.elementAt(i+1)).intValue();
      int x11=((Integer)Segmentos.elementAt(i+2)).intValue();
      int y11=((Integer)Segmentos.elementAt(i+3)).intValue();
      if (x0==x00 && y0==y00 && x1==x11 && y1==y11) return;
     }
    Segmentos.addElement(new Integer(x0));
    Segmentos.addElement(new Integer(y0));
    Segmentos.addElement(new Integer(x1));
    Segmentos.addElement(new Integer(y1));
   }

    /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *  Aade un nuevo punto al vector de puntos
   * @param x Coordenada x del punto
   * @param y Coordenada y del punto   
   */
  
  
  public void addPoint(int x,int y)
   {
     for (int i=0;i<Puntos.size();i+=2)
     {
      int x00=((Integer)Puntos.elementAt(i)).intValue();
      int y00=((Integer)Puntos.elementAt(i+1)).intValue();
      if (x==x00 && y==y00) return;
     }

     if (x>=0 && x<w && y>=0 && y<h) 
      {
       Puntos.addElement(new Integer(x));
       Puntos.addElement(new Integer(y));
      }
   
   }
   
   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *  Aade un nuevo punto al polgono en curso
   * @param x Coordenada x del nuevo punto del poligono
   * @param y Coordenada y del nuevo punto del poligono  
   */

  public void addPolyPoint(int x,int y)
   {
    
    for (int i=0;i<PoligonoActual.size();i+=2)
     {
      int x00=((Integer)PoligonoActual.elementAt(i)).intValue();
      int y00=((Integer)PoligonoActual.elementAt(i+1)).intValue();
      if (x==x00 && y==y00) return;
     }
    if (x>=0 && x<w && y>=0 && y<h) 
      {
       PoligonoActual.addElement(new Integer(x));
       PoligonoActual.addElement(new Integer(y));
       ultimoX=x;ultimoY=y;
      }
    }
    
    
   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *  Aade el poligono en curso al vector global de poligonos.
   * ste poligono ya estar cerrado.  
   */

  public void addPoligon()
   {
    Poligonos.add(PoligonoActual.clone());
    PoligonoActual.removeAllElements();
    ultimoX=ultimoY=-1;
    getParent().repaint();
   }
   
   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Se llama a ste mtodo cuando no hay que visualizar
   * bitmap de fondo.
   */ 
   
  public void NoBitmap() { backGround=null;}
  
   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Pone el bitmap de fondo a partir de la ruta del bitmap
   * @param ruta Ruta donde se encuentra el bitmap
   */ 
 
  public void PonBitmap(String ruta)
   {
    ImageIcon aux=new ImageIcon(ruta);
    if (aux.getImageLoadStatus()==MediaTracker.ERRORED) return; 
    backGround=aux;
    Image imagen =backGround.getImage();
    secuencia=new JIPSequence(JIPToolkit.getColorImage(imagen));
    Nuevo(imagen.getWidth (backGround.getImageObserver()),
          imagen.getHeight(backGround.getImageObserver()),backGround);
    info.AsociaSecuencia(secuencia);
    frame=banda=0;
    if (secuencia!=null) imgtmp=secuencia.getFrame(frame);
   	else imgtmp=null;
   }
 
 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Cambia el color del fondo del panel de scroll
   * @param nuevo Color nuevo del fondo del panel de scroll
   */ 
  
  public void ColorFondoScroll(Color nuevo)
     { 
       colorFondoScroll=nuevo;  
       setBackground(colorFondoScroll);
     }

   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Cambia el color de las lneas
   * @param nuevo Color nuevo de las lneas   
   */ 
  
  public void ColorLinea(Color nuevo)       { colorLinea=nuevo;  }

  /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Cambia el color de la lnea actual
   * @param nuevo Color nuevo de la lnea actual 
   */ 
  public void ColorLineaActual(Color nuevo) { colorLineaActual=nuevo; }  
  
  
  /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Cambia el fondo del recuadro de referencia para insercion de datos 
   * geomtricos cuando hacemos Archivo->Nuevo 
   * @param nuevo Color nuevo del fondo del cuadro de referencia
   */ 

  public void ColorFondo(Color nuevo)       { colorFondo=nuevo;  }
  
  
   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Cambia el color de los puntos
   * @param nuevo Color nuevo de los puntos
   */ 

  public void ColorPunto(Color nuevo)       { colorPunto=nuevo;  }

   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Cambia el color de los poligonos
   * @param nuevo Color nuevo de los poligonos
   */ 
 
  public void ColorPoligono(Color nuevo)    { colorPoligono=nuevo;}
  /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Cambia el color del polgono actual
   * @param nuevo Color nuevo del polgono en curso.
   */ 

  public void ColorPoligonoActual(Color nuevo){ colorPoligonoActual=nuevo; }

   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Cambia el color de los edges
   * @param nuevo Color nuevo de los edges
   */ 

  public void ColorEdges(Color nuevo)       { colorEdges=nuevo;  }

   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Cambia la variable de clase de resaltar los segmentos
   * @param b Booleano que indica si hay que resaltar los segmentos
   */ 

  public void ResaltaSegmentos(boolean b)   { resaltaSegmentos=b;}
  
 /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Cambia la variable de clase de resaltar los puntos
  * @param b Booleano que indica si hay que resaltar los puntos
  */ 

  public void ResaltaPuntos(boolean b)      { resaltaPuntos   =b;}
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Cambia la variable de clase de resaltar los poligonos
  * @param b Booleano que indica si hay que resaltar los poligonos
  */ 

  public void ResaltaPoligonos(boolean b)   { resaltaPoligonos=b;}
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Cambia la variable de clase de resaltar los edges
  * @param b Booleano que indica si hay que resaltar los edges
  */ 
  public void ResaltaEdges(boolean b)       { resaltaEdges=b;    }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *  Cambia la variable de clase de visualizar el Bitmap
  * @param b Booleano que indica si hay que visualizar el Bitmap
  */ 

  public void VerBitmap(boolean b)          { verBitmap=b;       }
    /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Cambia la variable de clase de visualizar los Segmentos
  * @param b Booleano que indica si hay que visualizar los Segmentos
  */ 

  public void VerSegmentos(boolean b)       { verSegmentos=b;    }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Cambia la variable de clase de visualizar los Puntos
  * @param b Booleano que indica si hay que visualizar los Puntos
  */ 

  public void VerPuntos(boolean b)          { verPuntos=b;       }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Cambia la variable de clase de visualizar los Poligonos
  * @param b Booleano que indica si hay que visualizar los Poligonos
  */ 

  public void VerPoligonos(boolean b)       { verPoligonos=b;    }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Cambia la variable de clase de visualizar los Edges
  * @param b Booleano que indica si hay que visualizar los Edges
  */ 

  public void VerEdges(boolean b)           { verEdges=b;        }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Devuelve el nmero del frame que estamos procesando actualmente
  * @return Nmero de frame actual
  */ 

  public int  GetFrameNum()                 { return frame;      }

  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Asocia un nuevo nombre a la secuencia actual
  * @param s Nuevo nombre de la secuencia
  */ 

  
  public void NombreSecuencia(String s)         
   { if (secuencia!=null) 
        {
         secuencia.setName(s); 
         info.AsociaSecuencia(secuencia);
        }
   }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Devuelve el nombre de la secuencia actual
  * @return Nombre de la secuencia actual
  */ 
 
  public String NombreSecuencia()
   { if (secuencia!=null) return secuencia.getName(); 
     else return null;
   }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Asocia un nuevo nombre al frame actual
  * @param s Nuevo nombre del frame
  */ 


  public void NombreFrame(String s)
   {
    if (secuencia==null) return;
    secuencia.getFrame(frame).setName(s);
    info.AsociaSecuencia(secuencia);
   }
   
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Asocia una nueva secuencia a la clase
  * @param s Nueva secuencia a asociar
  */ 
 
  public void SetSecuencia(JIPSequence s)   
   { secuencia=s;
   		if (secuencia!=null) imgtmp=secuencia.getFrame(frame);
   		else imgtmp=null;
     if (secuencia==null) return;
  
     JIPImage img=secuencia.getFrame(0);
     int t=img.getType();
     
     if (t==JIP.tBYTE || t==JIP.tBIT || t==JIP.tCOLOR || t==JIP.tREAL)

      { 
       Image img2=JIPToolkit.getAWTImage(img); 
       Nuevo(img.getWidth(),img.getHeight(),new ImageIcon(img2));
      }
      else
      if (  t==JIP.tPOINT || t==JIP.tPOLY || t==JIP.tSEGMENT || t==JIP.tEDGES){
        Image img2=JIPToolkit.getAWTImage(img); 
       Nuevo(img.getWidth(),img.getHeight(),null);

      }

     info.AsociaSecuencia(secuencia);
     info.UpdateGeo(estadoGeo);
     frame=banda=0;
     getParent().repaint();
   }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Devuelve la secuencia actual
  * @return Secuencia actual
  */ 

  
  public JIPSequence GetSecuencia() { factorEscala=100; return secuencia;  }

  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Aade un nuevo Frame a la secuencia, y ste frame
  * est compuesto de una sola imagen
  * @param img Imagen que formar el nuevo frame
  */ 

  
  public void addFrame(JIPImage img)        
   { 
     if (secuencia!=null) secuencia.addFrame(img);
     info.AsociaSecuencia(secuencia);
   }

  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Aade un nuevo Frame a la secuencia y este frame
  * es a su misma vez, una secuencia
  * @param s Secuencia que formar el nuevo frame (o frames)
  */ 
 
  public void addFrame(JIPSequence s)
   {
    if (secuencia==null || s==null) return;
    secuencia.appendSequence(s);
    info.AsociaSecuencia(secuencia);
   }
 
 /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Duplica el frame actual. Utilizado cuando se
  * aplican algoritmos sobre los resultados de otros
  * para no perder resultados anteriores.
  */ 

  public void duplicaFrame()
   {
    secuencia.addFrame(secuencia.getFrame(frame));
    info.AsociaSecuencia(secuencia);
   }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Cambia el Frame  
  * @param img Nueva imagen
  */
 
   
  public void ChangeFrame(JIPImage img)
   {
    secuencia.setFrame(img,frame);
    info.AsociaSecuencia(secuencia);
   }
 
 /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Elimina el frame actual (si no es el ltimo)
  */
  
  public void removeFrame()
   {
    secuencia.removeFrame(frame);
    backGround=null;
    QuitarVista();
    info.AsociaSecuencia(secuencia);
    if (secuencia!=null) CambiaFrame(0);
   }



  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Elimina la banda actual (si no es la ltima)
  */

  
  public void removeBand()
   {
    JIPImage aux=secuencia.getFrame(frame);
    aux.removeBand(banda);
    secuencia.setFrame(aux,frame);
    info.AsociaSecuencia(secuencia);
   }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Nos informa de la longitud del ltimo segmento
  * @return Longitud del ltimo segmento
  */

  public float LongitudUltimoSegmento()
   {
    if (Segmentos.size()==0) return -1f;
    int tam=Segmentos.size();
    int x0=((Integer)Segmentos.elementAt(tam-4)).intValue();
    int y0=((Integer)Segmentos.elementAt(tam-3)).intValue();
    int x1=((Integer)Segmentos.elementAt(tam-2)).intValue();
    int y1=((Integer)Segmentos.elementAt(tam-1)).intValue();
    return  (float)Math.sqrt(Math.pow(x0-x1,2)+Math.pow(y0-y1,2));
   }

  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Nos informa de la longitud del Segmento Seleccionado
  * @return Longitud del Segmento Seleccionado
  */
   
   
  public float LongitudSegmentoSeleccionado()
   {
    if (Segmentos.size()==0 || x1Sel==-1 || tipoSel!=SEG) return -1f;
    return  (float)Math.sqrt(Math.pow(x0Sel-x1Sel,2)+Math.pow(y0Sel-y1Sel,2));
   }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Nos informa de la distancia entre los dos ltimos puntos
  * @return Distancia entre los dos ltimos puntos
  */

  public float DistanciaUltimosPuntos()
   {
    if (Puntos.size()<4) return -1f;
    int tam=Puntos.size();
    int x0=((Integer)Puntos.elementAt(tam-4)).intValue();
    int y0=((Integer)Puntos.elementAt(tam-3)).intValue();
    int x1=((Integer)Puntos.elementAt(tam-2)).intValue();
    int y1=((Integer)Puntos.elementAt(tam-1)).intValue();
    return  (float)Math.sqrt(Math.pow(x0-x1,2)+Math.pow(y0-y1,2));
   }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Nos informa de los datos de los segmentos, en los que
  * adems de sus coordenadas, se especifica la longitud
  * @return Array con los datos de los segmentos
  */
 
   
  public Object[][] DatosSegmentos()
   {
    int x0,y0,x1,y1;
    float longitud;
    Object datos[][]=new Object[Segmentos.size()/4][6];
    for (int i=0;i<Segmentos.size();i+=4)
     {
       
       x0=((Integer)Segmentos.elementAt(i)).intValue();
       y0=((Integer)Segmentos.elementAt(i+1)).intValue();
       x1=((Integer)Segmentos.elementAt(i+2)).intValue();
       y1=((Integer)Segmentos.elementAt(i+3)).intValue();
       longitud=(float)Math.sqrt(Math.pow(x0-x1,2)+Math.pow(y0-y1,2));
       datos[i/4][0]=new Integer(i/4);
       datos[i/4][1]=Segmentos.elementAt(i);
       datos[i/4][2]=Segmentos.elementAt(i+1);
       datos[i/4][3]=Segmentos.elementAt(i+2);
       datos[i/4][4]=Segmentos.elementAt(i+3);
       datos[i/4][5]=new Float(longitud);
     }
    return(datos);
   }
 
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Carga una secuencia desde un fichero, a la clase
  * @param fich Nombre del fichero que contiene la secuencia
  */

   
  public void CargaSecuencia(String fich)
   { 
     secuencia=JIPToolkit.getSeqFromFile(fich); 
     if (secuencia!=null) imgtmp=secuencia.getFrame(0);
   		else imgtmp=null;
     if (secuencia==null) return;
     JIPImage img=secuencia.getFrame(0);
     int t=img.getType();
     Segmentos.removeAllElements();
     Puntos.removeAllElements();
     Poligonos.removeAllElements();
     Edges.removeAllElements();
     indiceSeg=indicePunto=indicePoly=indiceEdge=0;
     backGround=null;
     info.AsociaSecuencia(secuencia);
     frame=banda=0;
     getParent().repaint();
   }

  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Devuelve el factor de escala segun el total de factores 
  * de escala aplicados
  * @return Factor de Escala
  */
   
  public double secuenciaZoom(){
    double sol=1.0;
    
    for (int i=0; i< factoresEscalas.size(); i++){
      sol=sol*(double)((((Integer)(factoresEscalas.elementAt(i))).intValue())/100.0);
    }    
    return(sol);
  }
    
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Cambia al nmero de frame que se le pasa como parmetro
  * @param n Nmero de frame que vamos a cargar
  */  
  public void CambiaFrame(int n)   
   {
    if ( secuencia==null ||  n>secuencia.getNumFrames()) {
    			imgtmp=null;
    		 return;
    }
    JIPImage img=secuencia.getFrame(n);
    int t=img.getType();
    frame=n;
    banda=0;
    if (secuencia!=null) imgtmp=secuencia.getFrame(frame);
   	else imgtmp=null;

    if (t==JIP.tBYTE || t==JIP.tBIT || t==JIP.tCOLOR || t==JIP.tREAL || t==JIP.tWORD)
      { 
       Image img2=JIPToolkit.getAWTImage(img);
       int fe=(int)(secuenciaZoom()*100);
       
       if (estadoGeo==0){ // estoy en modo zoom
        Image zoom;
        if (t==JIP.tCOLOR)
          zoom=img2.getScaledInstance((img.getWidth()*fe)/100,(img.getHeight()*fe)/100,0);
        else        
          zoom=img2.getScaledInstance((img.getWidth()*fe)/100,(img.getHeight()*fe)/100,0);
          
        backGround=new ImageIcon(zoom);
        w=zoom.getWidth (backGround.getImageObserver());
        h=zoom.getHeight(backGround.getImageObserver());
    
        worg=secuencia.getFrame(frame).getWidth();
        horg=secuencia.getFrame(frame).getHeight();
        
        remove(zona);
        zona=new Box(BoxLayout.Y_AXIS).createRigidArea(new Dimension(w,h));
        add(zona);
       }
       else  Nuevo(img.getWidth(),img.getHeight(),new ImageIcon(img2));

       for (int i=0;i<indiceSeg && Segmentos.size()>0;i++)   Segmentos.remove(0);
       for (int i=0;i<indicePunto && Puntos.size()>0;i++) Puntos.remove(0);
       for (int i=0;i<indicePoly && Poligonos.size()>0;i++) Poligonos.remove(0);
       for (int i=0;i<indiceEdge && Edges.size()>0;i++)  Edges.remove(0);
      
       indiceSeg=indicePunto=indicePoly=indiceEdge=0;
       visualizando.removeAllElements();
      }
    else
     {
    
      Vector v=(Vector)img.getVector().clone();

      for (int i=0;i<visualizando.size();i++) 
          if (n==((Integer)visualizando.elementAt(i)).intValue()) return;
      visualizando.add(new Integer(n));
      int tamX=0,tamY=0;
      switch(t)
       {
        case JIP.tSEGMENT:
           indiceSeg+=v.size();
           Segmentos.addAll(0,v);
           break;
        case JIP.tPOINT:
           indicePunto+=v.size();
           Puntos.addAll(0,v);
           break;
        case JIP.tPOLY:
           indicePoly+=v.size();
           Poligonos.addAll(0,v);
           break;
        case JIP.tEDGES:
           indiceEdge+=v.size();
           Edges.addAll(0,v);
           break;
       }
      
      if (backGround==null) Nuevo(img.getWidth(),img.getHeight(),null);
     }
    
    n=img.getNumBands();
    if (t==JIP.tCOLOR) n=-1;
    info.BandasFrame(img,n);
    getParent().repaint();

   }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Quita todos los elementos geomtricos
  */  

  public void QuitarVista() 
   {
    for (int i=0;i<indiceSeg && Segmentos.size()>0;i++)   Segmentos.remove(0);
    for (int i=0;i<indicePunto && Puntos.size()>0;i++) Puntos.remove(0);
    for (int i=0;i<indicePoly && Poligonos.size()>0;i++)  Poligonos.remove(0);
    for (int i=0;i<indiceEdge && Edges.size()>0;i++)  Edges.remove(0);
    indiceSeg=indicePunto=indicePoly=indiceEdge=0;
    visualizando.removeAllElements();
   }
       
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Cambia al nmero de banda que se le pasa como parmetro
  * @param n Nmero de banda que vamos a cargar
  */  
                           
  public void CambiaBanda(int n)   
   {
     if (n==banda || secuencia==null || 
        n>secuencia.getFrame(frame).getNumBands()) return;
     JIPImage img=secuencia.getFrame(frame);
     int fe=(int)(secuenciaZoom()*100);
     int t=img.getType();

     if (t==JIP.tBYTE || t==JIP.tBIT  || t==JIP.tREAL || t==JIP.tWORD)
      {
      Image img2=JIPToolkit.getAWTImage(img,n); 
      
      if (img2!=null){
      if (estadoGeo==0){ // estoy en modo zoom
        Image zoom;

        zoom=img2.getScaledInstance((img.getWidth()*fe)/100,(img.getHeight()*fe)/100,0);
          
        backGround=new ImageIcon(zoom);
        w=zoom.getWidth (backGround.getImageObserver());
        h=zoom.getHeight(backGround.getImageObserver());
    
        worg=secuencia.getFrame(frame).getWidth();
        horg=secuencia.getFrame(frame).getHeight();
        
        remove(zona);
        zona=new Box(BoxLayout.Y_AXIS).createRigidArea(new Dimension(w,h));
        add(zona);
      }
       else Nuevo(img.getWidth(),img.getHeight(),new ImageIcon(img2));
      }
      }
    banda=n;
    getParent().repaint();
   }




  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Elimina el ltimo segmento
  */  

  
  public void EliminarUltimoSegmento()
   {
    if (Segmentos.size()>=4 && Segmentos.size()>indiceSeg) 
       for (int r=0;r<4;r++)
           Segmentos.removeElementAt(Segmentos.size()-1);
    getParent().repaint();
   }
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Elimina el ltimo punto
  */  

   
  public void EliminarUltimoPunto()
   {
    if (Puntos.size()>=2 && Segmentos.size()>indiceSeg) 
       for (int r=0;r<2;r++)
           Puntos.removeElementAt(Puntos.size()-1);
    getParent().repaint();
   }
   
   /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Elimina el ltimo poligono
  */  

  public void EliminarUltimoPoligono()
   {
    if (Poligonos.size()>=1 && Poligonos.size()>indicePoly) 
       Poligonos.removeElementAt(Poligonos.size()-1);
    getParent().repaint();
   }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Elimina lo que est seleccionado
  */  

  
  public void EliminarSeleccion()
   {
    if (tipoSel==PUNTO)
     {
      for (int i=0;i<Puntos.size();i+=2)
       {
        if (x0Sel==((Integer)Puntos.elementAt(i)).intValue()
            && y0Sel==((Integer)Puntos.elementAt(i+1)).intValue())
           {
            if (i<indicePunto)
              { 
               new Dialogo(this).
                 Error("No se pueden eliminar datos de un frame de secuencia","ERROR");
               return;
              };
            Puntos.removeElementAt(i+1);
            Puntos.removeElementAt(i);
            x0Sel=x1Sel=y0Sel=y1Sel=tipoSel=-1;
            getParent().repaint();
           }
       }
     }
    if (tipoSel==SEG)
     {
      for (int i=0;i<Segmentos.size();i+=4)
       {
        if (x0Sel==((Integer)Segmentos.elementAt(i)).intValue()
            && y0Sel==((Integer)Segmentos.elementAt(i+1)).intValue()
            && x1Sel==((Integer)Segmentos.elementAt(i+2)).intValue()
            && y1Sel==((Integer)Segmentos.elementAt(i+3)).intValue())
           {
            if (i<indiceSeg)
              { 
               new Dialogo(this).
                 Error("No se pueden eliminar datos de un frame de secuencia","ERROR");
               return;
              };

            Segmentos.removeElementAt(i+3);
            Segmentos.removeElementAt(i+2);
            Segmentos.removeElementAt(i+1);
            Segmentos.removeElementAt(i);
            x0Sel=x1Sel=y0Sel=y1Sel=tipoSel=-1;
            getParent().repaint();
           }
       }
     }

   }
   
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Nos da el nuevo valor del  punto segun el factor de escala
  * Si no hacemnos zoom el factor vale 100, por lo tanto, mul = 1
  * de esta forma (vorg*mul)+(mul-1)=vorg y no se produce nungun cambio. 
  * @param vorg
  * @return Nuevo valor del punto
  */
   
  public int getZoomValue(int vorg){
   double dsol;
   double dmul;
   double dvorg=(double)vorg;
   dsol=dvorg; // por defecto

   for (int fa=0; fa<factoresEscalas.size(); fa++){
    factorEscala = ((Integer)(factoresEscalas.elementAt(fa))).intValue();
    dmul=(factorEscala/100.0);
    dsol=( (dvorg*dmul)+(dmul-1) );
    dvorg=dsol;
   }
   return ((int)dsol);
  }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * @param porcent
  */

  public void VentanaZoom(int porcent)
   {
     
    if (secuencia==null || porcent==100) return;
    
    factorEscala=porcent;
    factoresEscalas.addElement(new Integer(factorEscala));
    estadoGeo=0; // desactivo la geometria.
   
    Image zoom;
    if (secuencia.getFrame(frame).getType()==JIP.tCOLOR)
        zoom=JIPToolkit.getAWTImage(secuencia.getFrame(frame)).
               getScaledInstance((w*porcent)/100,(h*porcent)/100,0);
    else        
        zoom=JIPToolkit.getAWTImage(secuencia.getFrame(frame),banda).
          getScaledInstance((w*porcent)/100,(h*porcent)/100,0);

    backGround=new ImageIcon(zoom);
    w=zoom.getWidth (backGround.getImageObserver());
    h=zoom.getHeight(backGround.getImageObserver());

    worg=secuencia.getFrame(frame).getWidth();
    horg=secuencia.getFrame(frame).getHeight();
   
    remove(zona);
    zona=new Box(BoxLayout.Y_AXIS).createRigidArea(new Dimension(w,h));
    add(zona);
    info.UpdateGeo(estadoGeo);
    getParent().repaint();
   }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Exporta los datos geomtricos de los vectores temporales a ascii
  */
  
  public void ExportarAscii() {
	  	JFileChooser abreFich = new JFileChooser();
  		String ascii="Ascii.txt";
			FileWriter fOut;
			try {
					abreFich.setCurrentDirectory(new File("."));
          abreFich.setSelectedFile(new File("Ascii.txt"));
					int returnVal = abreFich.showSaveDialog(this);
        			if (returnVal == abreFich.APPROVE_OPTION) {
              		File fich = abreFich.getSelectedFile();
				   				fOut=new FileWriter(fich);
   								if (!Puntos.isEmpty()) {
		   			  			fOut.write("PUNTOS "+Puntos.size()/2+"\n");
   			  					for (int x=0;x<Puntos.size();x+=2) {
   			  							fOut.write(((Integer)Puntos.elementAt(x)).toString());
   			  							fOut.write(" ");
		   			  					fOut.write(((Integer)Puntos.elementAt(x+1)).toString());
  			  							fOut.write("\n");
   			  					}
   								}
   				
   								if (!Segmentos.isEmpty()) {
		   			  				fOut.write("SEGMENTOS "+Segmentos.size()/4+"\n");
   			  						for (int x=0;x<Segmentos.size();x+=4) {
   			  								fOut.write(((Integer)Segmentos.elementAt(x)).toString());
   			  								fOut.write(" ");
		   			  						fOut.write(((Integer)Segmentos.elementAt(x+1)).toString());
		   			  						fOut.write(" ");
		   			  						fOut.write(((Integer)Segmentos.elementAt(x+2)).toString());
													fOut.write(" ");
		   			  						fOut.write(((Integer)Segmentos.elementAt(x+3)).toString());
  			  								fOut.write("\n");
   			  						}
   								}
   								if (!Poligonos.isEmpty()) {
   										Vector aux=new Vector();
		   			  				fOut.write("POLIGONOS "+Poligonos.size()+"\n");
   			  						for (int x=0;x<Poligonos.size();x++) {
   			  			  				aux=(Vector)((Vector)Poligonos.elementAt(x)).clone(); 
   			  			  				fOut.write(aux.size()+" : ");
   			  								for (int y=0;y<aux.size();y++) {
   			  									fOut.write(((Integer)aux.elementAt(y)).toString());
   			  									fOut.write(" ");
   			  					
				   			  				}
   			  								fOut.write("\n");
   			  						}
   								}
   							fOut.close();
        			}
  		System.out.println("Fichero guardado OK");   				
   		}catch(Exception err) {}

	  
  }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Importa los datos geomtricos de un archivo Ascii a los vectores temporales
  */

  public void ImportarAscii() {
  	 String cadena=new String("Ascii.txt");
  	 boolean graba;
   	 boolean mensaje=false;
 		 int c1,c2,c3,c4,cantidad,numpoints;
     try {
	     	JFileChooser abreFich = new JFileChooser();
				abreFich.setCurrentDirectory(new File("."));
				int returnVal = abreFich.showOpenDialog(this);
        if (returnVal == abreFich.APPROVE_OPTION) {
          	File fich = abreFich.getSelectedFile();
     				FileInputStream fentrada=new FileInputStream(fich);
      			Reader r = new BufferedReader(new InputStreamReader(fentrada));
      			StreamTokenizer st = new StreamTokenizer(r);
      			Integer ent=new Integer(0);
      			Vector PolyAux=new Vector();
   					Vector P=new Vector();
   					
    				String titulo=new String("");
		      	   	st.nextToken(); 
      	  			if (st.ttype != StreamTokenizer.TT_EOF) {
      				 		titulo=st.sval;
			       		 		if (titulo.compareTo("PUNTOS")==0) {
      				         		VaciarPuntos();
      	  		         		st.nextToken();  cantidad=(int)st.nval;
      		    		     		for (int kp=0;kp<cantidad*2;kp+=2) {
		      			            		st.nextToken(); c1=(int)st.nval;
    		  			            		st.nextToken(); c2=(int)st.nval;
      					            		addPoint(c1,c2);
  															if (c1<0 || c1>=w || c2<0 || c2>=h) {
				  													mensaje=true;
			  												}
		
      		     		     		}
			       		       		st.nextToken(); 
			       		 		}
      	         		if (st.ttype != StreamTokenizer.TT_EOF) {
      	              	titulo=st.sval;
      	              		if (titulo.compareTo("SEGMENTOS")==0) {
      	        		       		VaciarSegmentos();
      	        		       		st.nextToken(); cantidad=(int)st.nval;
      	        		       		for (int kp=0;kp<cantidad*4;kp+=4) {
      	        				       		st.nextToken(); c1=(int)st.nval;
      	        							 		st.nextToken(); c2=(int)st.nval;
			 												 		st.nextToken(); c3=(int)st.nval;
												       		st.nextToken(); c4=(int)st.nval;
												       		addSegment(c1,c2,c3,c4);     	        		
												       		if (c1<0 || c1>=w || c3<0 || c3>=w || c2<0 || c2>=h || c2<0 || c2>=h) {
																	 		mensaje=true;
												       		}	
		      	        		        }
    		  	  					        st.nextToken();
      	  					  		}
      	  					  		if (st.ttype !=StreamTokenizer.TT_EOF) {
      	  					  	  		titulo=st.sval;
      	  					  	  		if (titulo.compareTo("POLIGONOS")==0) {
      	  					  	        		VaciarPoligonos();
      	  					  	        		st.nextToken(); cantidad=(int)st.nval;
      	  					  	        		for (int kp=0;kp<cantidad;kp++) {
		      	  					  	        		st.nextToken(); numpoints=(int)st.nval;
      	  					  	        				st.nextToken(); // LOS :
      	  					  	        				graba=true;	
																				for (int kl=0;kl<numpoints;kl+=2) {
																						st.nextToken(); c1=(int)st.nval;
																						st.nextToken(); c2=(int)st.nval;
																						if (c1<0 || c1>=w || c2<0 || c2>=h) {
																								graba=false;
																								mensaje=true;
																						}
																				
																						ent=new Integer(c1);
																						P.addElement(ent);
																						ent=new Integer(c2);
																						P.addElement(ent);
																				}	
																				if (graba==true) {
																						PolyAux=(Vector)P.clone();
																						Poligonos.addElement(PolyAux);
																				}
																				P.removeAllElements();
      	  							  	        }
      	  							  	        
      	  					  			  } 
		      	  					  	
    		  	  					  } // del IF EOF 3
						
    		  	          }	// del IF EOF2
     	          	
      	  			}	// del IF EOF1
      	  if (mensaje==true) 
 	   					new Dialogo(this).Error("Hay puntos cuyas coordenadas salen del tamao de la imagen y han sido omitidos","ATENCION");				
        	}
					

      }catch(FileNotFoundException e) { }	
			
			catch(IOException e) 
              { System.out.println("IO Exception"); }
			
			info.AsociaSecuencia(secuencia);
    	getParent().repaint();
    

   }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Pasa los vectores que contienen los elementos
  * geomtricos de la clase a frames independientes.
  * Cada tipo geomtrico estar en un frame distinto.
  */
  
  
  public void GrabaGeometria() {
  	JIPImage i;
    Vector P = (Vector)Puntos.clone();
    Vector S = (Vector)Segmentos.clone();
    Vector PL= (Vector)Poligonos.clone();
    Vector E = (Vector)Edges.clone();
    
    
    for (int j=0;j<indiceSeg;j++)   S.remove(0);
    
    for (int j=0;j<indicePunto;j++) P.remove(0);
    
    for (int j=0;j<indicePoly;j++)  PL.remove(0);
    
    for (int j=0;j<indiceEdge;j++)  E.remove(0);
    
  	if (!P.isEmpty())  {
  		 		i=new JIPImage(w,h,JIP.tPOINT,P);
      	  if (secuencia!=null) 
            secuencia.addFrame(i);
          else{
            secuencia=new JIPSequence(i);
            
          }
  	}
  	if (!S.isEmpty())  {
		  		i=new JIPImage(w,h,JIP.tSEGMENT,S);
  				if (secuencia!=null) 
            secuencia.addFrame(i);
          else{
            secuencia=new JIPSequence(i);
          }
    }
  	if (!PL.isEmpty()) {
  				i=new JIPImage(w,h,JIP.tPOLY,PL);
  	      if (secuencia!=null) 
            secuencia.addFrame(i);
          else{
            secuencia=new JIPSequence(i);
          }
  	}
  	if (!E.isEmpty()) {
  				i=new JIPImage(w,h,JIP.tEDGES,E);
  		    if (secuencia!=null) 
            secuencia.addFrame(i);
          else{
            secuencia=new JIPSequence(i);
          }
    }
    frame=0;
    banda=0;
    
    if (secuencia!=null) imgtmp=secuencia.getFrame(frame);
   	else imgtmp=null;
    info.AsociaSecuencia(secuencia);
    indiceSeg=Segmentos.size();        
    indicePunto=Puntos.size();
    indicePoly=Poligonos.size();
    indiceEdge=Edges.size();
    
    getParent().repaint();
  }
  						
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *    Aade un frame vacio, del tipo especificado por parmetro 
  * @param tipo Tipo geomtrico del que va a ser el frame
  */

	public void AadeFrameVacio(int tipo) {
			Vector elVector=new Vector();
			JIPImage i=new JIPImage(w,h,tipo,elVector);
   	  if (secuencia!=null) 
        secuencia.addFrame(i);
      else
        secuencia=new JIPSequence(i);
      info.AsociaSecuencia(secuencia);

  }

	/**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *    Elimina los puntos del Vector de Puntos de la clase
  */

              
  public void VaciarPuntos() {
  		Puntos.removeAllElements();
  		indicePunto=0;
      info.AsociaSecuencia(secuencia);
    	getParent().repaint();
      for (int i=0;i<visualizando.size();i++)
      {
       if (secuencia.getFrame(((Integer)visualizando.elementAt(i)).intValue()).getType()==JIP.tPOINT)
        { visualizando.removeElementAt(i); i--; }
      }
  }
  
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *    Elimina los segmentos del Vector de Segmentos de la clase
  */

  public void VaciarSegmentos() {
  		Segmentos.removeAllElements();
  		indiceSeg=0;        
      info.AsociaSecuencia(secuencia);
  	  getParent().repaint();
      for (int i=0;i<visualizando.size();i++)
      {
       if (secuencia.getFrame(((Integer)visualizando.elementAt(i)).intValue()).getType()==JIP.tSEGMENT)
        { visualizando.removeElementAt(i); i--; }
      }

  }

/**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *    Elimina los polgonos del Vector de Polgonos de la clase
  */

  public void VaciarPoligonos() {
  		Poligonos.removeAllElements();
      indicePoly=0;
      info.AsociaSecuencia(secuencia);
    	getParent().repaint();
      for (int i=0;i<visualizando.size();i++)
      {
       if (secuencia.getFrame(((Integer)visualizando.elementAt(i)).intValue()).getType()==JIP.tPOLY)
        { visualizando.removeElementAt(i); i--; }
      }

  }

	/**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *    Elimina todos los vectores que contienen geometra de la clase
  */

  public void VaciarTodos() {
  		Puntos.removeAllElements();
  		Segmentos.removeAllElements();
  		Poligonos.removeAllElements();
        Edges.removeAllElements();
 	    indiceSeg=0;        
  	  indicePunto=0;
    	indicePoly=0;
      info.AsociaSecuencia(secuencia);
      visualizando.removeAllElements();
    	getParent().repaint();
  }
  	
  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  * Captura los eventos que se producen en el panel de informacin
  * @param e Evento
  */
  
  public void actionPerformed(ActionEvent e) 
      {
       if (e.getActionCommand().equals("Segmentos"))
        { modo=SEG; }
       if (e.getActionCommand().equals("Puntos"))
        { modo=PUNTO; arrastrando=false;}
       if (e.getActionCommand().equals("Poligonos"))
        { modo=POLY; arrastrando=false;}
       
       if (e.getActionCommand().equals("comboBoxChanged"))
        { 
         
         String item=(String)((JComboBox)e.getSource()).getSelectedItem();
         int idx=((JComboBox)e.getSource()).getSelectedIndex();
         if (item==null) return;
         if (item.equals("Aadir"))
            {
             accion=0;
             x0Sel=y0Sel=x1Sel=y1Sel=idxPolySel=-1;
             info.UpdateSel(-1,-1,-1,-1,"[sin seleccion]");
             info.UpdateGeo(estadoGeo);
             return;
            }
         if (item.equals("Seleccionar")) 
            { accion=1; return; }
         
         if (secuencia==null) return;
         char c=' ';
         if (item!=null) c=item.charAt(0); 
         if (c>='0' && c<='9')
            CambiaFrame(((JComboBox)e.getSource()).getSelectedIndex());
         else
          {
           CambiaBanda(((JComboBox)e.getSource()).getSelectedIndex());
          }
        }

      }

  /**<P><FONT COLOR="red">
  *<B>Descripcin:</B><BR>
  *<FONT COLOR="blue">
  *   Clase que implementa el MouseListener
  * 
  */
   
     
  class MyMouseListener extends MouseAdapter implements MouseMotionListener 
   {
     
    /**<P><FONT COLOR="red">
    *<B>Descripcin:</B><BR>
    *<FONT COLOR="blue">
    *   Mtodo que se llama en caso de que se presione el mouse
    * @param e Evento
    */
 
    public void mousePressed (MouseEvent e)
     {
     if (estadoGeo==1){
      if (accion==1) // Seleccionar
       {
        if (modo==PUNTO)
         {
          if (Puntos.size()==0) return;
          xini=e.getX();
          yini=e.getY();
          float dist=99999,distAux;
          int min=-1,x0=-1,y0=-1;
          for (int i=0;i<Puntos.size();i+=2)
           {
            x0=((Integer)Puntos.elementAt(i)).intValue();
            y0=((Integer)Puntos.elementAt(i+1)).intValue();
            distAux=(float)Math.sqrt(Math.pow(x0-xini,2)+ Math.pow(y0-yini,2));
            if (distAux<dist) { dist=distAux; min=i; }
           }
          x0Sel=((Integer)Puntos.elementAt(min)).intValue();
          y0Sel=((Integer)Puntos.elementAt(min+1)).intValue();
          tipoSel=PUNTO;
          info.UpdateSel(x0Sel,y0Sel,x0Sel,y0Sel,"Punto");
          info.UpdateGeo(estadoGeo);
          getParent().repaint();
          return;
         }
        if (modo==SEG)
         {
          if (Segmentos.size()==0) return;
          xini=e.getX();
          yini=e.getY();
          float dist=99999;
          float distAux;
          int min=-1,x0=-1,y0=-1,x1=-1,y1=-1;
          for (int i=0;i<Segmentos.size();i+=4)
           {
            x0=((Integer)Segmentos.elementAt(i)).intValue();
            y0=((Integer)Segmentos.elementAt(i+1)).intValue();
            x1=((Integer)Segmentos.elementAt(i+2)).intValue();
            y1=((Integer)Segmentos.elementAt(i+3)).intValue();
            distAux=(float)Math.sqrt(Math.pow(x0-xini,2)+ Math.pow(y0-yini,2));
            if (distAux<dist) 
               { dist=distAux; min=i; }
            distAux=(float)Math.sqrt(Math.pow(x1-xini,2)+ Math.pow(y1-yini,2));
            if (distAux<dist) 
               { dist=distAux; min=i; }
           }
         x0Sel=((Integer)Segmentos.elementAt(min)).intValue();
         y0Sel=((Integer)Segmentos.elementAt(min+1)).intValue();
         x1Sel=((Integer)Segmentos.elementAt(min+2)).intValue();
         y1Sel=((Integer)Segmentos.elementAt(min+3)).intValue();
         info.UpdateSel(x0Sel,y0Sel,x1Sel,y1Sel,"Segmento");
         info.UpdateGeo(estadoGeo);
         tipoSel=SEG;
         getParent().repaint();
         return;
         }
       }
      if (modo==SEG || (modo==POLY && ultimoX==-1))
        { 
         xini = e.getX();
         yini = e.getY();
         xfin = xini;
         yfin = yini;
         if (modo==POLY) { ultimoX=xini; ultimoY=yini; }
        }
      if (modo==POLY && ultimoX!=-1)
       {
        xini=ultimoX;
        yini=ultimoY;
        xfin = e.getX();
        yfin = e.getY();
         if (xfin>w-1) xfin=w-1;
          if (yfin>h-1) yfin=h-1;
          if (xfin<0) xfin=0;
          if (yfin<0) yfin=0;
       }
      if (modo==SEG || modo==POLY)
       {
        if (xini>=0 && xini<w && yini>=0 && yini<h)       
        arrastrando=true;
       }
      if (modo==PUNTO)
       {
        xini = e.getX();
        yini = e.getY();
        addPoint(xini,yini);
        getParent().repaint();
       }
     }
     }
     
    /**<P><FONT COLOR="red">
    *<B>Descripcin:</B><BR>
    *<FONT COLOR="blue">
    *   Mtodo que se llama en caso de que se suelte el mouse
    * @param e Evento
    */
 
    public void mouseReleased(MouseEvent e)
     {
     if (estadoGeo==1){
      if (accion==1) return; //Seleccionando
      if (modo==SEG)
       {
        arrastrando=false;
        addSegment(xini,yini,xfin,yfin);
        info.UpdateInfo(w,h,e.getX(),e.getY(),Segmentos.size()/4,Puntos.size()/2,Poligonos.size(),xini,yini,xfin,yfin,imgtmp,banda);
        info.UpdateGeo(estadoGeo);
        getParent().repaint();
       }
      if (modo==POLY)
       {
        if (xini==xfin && yini==yfin) 
         {
          if (PoligonoActual.size()>(2*2)) addPoligon();
         }
        else
         {
          addPolyPoint(xini,yini);
          addPolyPoint(xfin,yfin);
         }
        getParent().repaint();
       }
     }
     }
     
     /**<P><FONT COLOR="red">
    *<B>Descripcin:</B><BR>
    *<FONT COLOR="blue">
    *   Mtodo que se llama al mover el ratn
    * @param e Evento
    */

    public void mouseMoved (MouseEvent e) 
     {
     
      if (modo!=PUNTO && accion==0 && estadoGeo==1){
         info.UpdateInfo(w,h,e.getX(),e.getY(),Segmentos.size()/4,Puntos.size()/2,Poligonos.size(),xini,yini,xfin,yfin,imgtmp,banda);
         info.UpdateGeo(estadoGeo);
      }
      else{
        int mx,my;
        mx=e.getX();
        my=e.getY();
        factorEscala=(int)(((double)w/(double)worg)*100.0); // factor de escala en funcion de las resoluciones
        double mul=(factorEscala/100.0);
        if (estadoGeo==0 && mul>1){ // geometria desactivada -> estamos haciendo zoom
          int xs,ys;
          ys=(int)((my/mul)+1);
          xs=(int)((mx/mul)+1);
          info.UpdateInfo((int)(w/mul),(int)(h/mul),xs,ys,Segmentos.size()/4,Puntos.size()/2,Poligonos.size(),xini,yini,xini,yini,imgtmp,banda);
          info.UpdateGeo(estadoGeo);
        }
        else{
          double dmul=factorEscala/100.0;
          if (dmul<1){
            int xs,ys;
            ys=(int)(my/dmul);
            xs=(int)(mx/dmul);
            info.UpdateInfo((int)(w/dmul),(int)(h/dmul),xs,ys,Segmentos.size()/4,Puntos.size()/2,Poligonos.size(),xini,yini,xini,yini,imgtmp,banda);
            info.UpdateGeo(estadoGeo);
          }
          else{
            info.UpdateInfo(w,h,mx,my,Segmentos.size()/4,Puntos.size()/2,Poligonos.size(),xini,yini,xini,yini,imgtmp,banda);
            info.UpdateGeo(estadoGeo);
          }
        }
      }
     
     }
    /**<P><FONT COLOR="red">
    *<B>Descripcin:</B><BR>
    *<FONT COLOR="blue">
    *   Mtodo que se llama al arrastrar el ratn (mover con botn pulsado)
    * @param e Evento
    */

     
    public void mouseDragged(MouseEvent e) 
    {
      if (modo!=PUNTO && accion==0 && estadoGeo==1){
         info.UpdateInfo(w,h,e.getX(),e.getY(),Segmentos.size()/4,Puntos.size()/2,Poligonos.size(),xini,yini,xfin,yfin,imgtmp,banda);
         info.UpdateGeo(estadoGeo);
      }
      else{
        int mx,my;
        mx=e.getX();
        my=e.getY();
        factorEscala=(int)(((double)w/(double)worg)*100.0); // factor de escala en funcion de las resoluciones
        double mul=(factorEscala/100.0);
        if (estadoGeo==0 && mul>1){ // geometria desactivada -> estamos haciendo zoom
          int xs,ys;
          ys=(int)((my/mul)+1);
          xs=(int)((mx/mul)+1);
          info.UpdateInfo((int)(w/mul),(int)(h/mul),xs,ys,Segmentos.size()/4,Puntos.size()/2,Poligonos.size(),xini,yini,xini,yini,imgtmp,banda);
          info.UpdateGeo(estadoGeo);
        }
        else{
          double dmul=factorEscala/100.0;
          if (dmul<1){
            int xs,ys;
            ys=(int)(my/dmul);
            xs=(int)(mx/dmul);
            info.UpdateInfo((int)(w/dmul),(int)(h/dmul),xs,ys,Segmentos.size()/4,Puntos.size()/2,Poligonos.size(),xini,yini,xini,yini,imgtmp,banda);
            info.UpdateGeo(estadoGeo);
          }
          else{
            info.UpdateInfo(w,h,mx,my,Segmentos.size()/4,Puntos.size()/2,Poligonos.size(),xini,yini,xini,yini,imgtmp,banda);
            info.UpdateGeo(estadoGeo);
          }
        }
      }
      if (estadoGeo==1){
        if (accion==1) return; // Seleccionar
        if (modo==SEG || modo==POLY)
         {
          if (arrastrando)
           {
            xfin = e.getX();
            yfin = e.getY();
            if (xfin>w-1) xfin=w-1;
            if (yfin>h-1) yfin=h-1;
            if (xfin<0) xfin=0;
            if (yfin<0) yfin=0;
            getParent().repaint(); 
           }
         }
      }
    }
  }
   
   /**<P><FONT COLOR="red">
    *<B>Descripcin:</B><BR>
    *<FONT COLOR="blue">
    *   Metodo que realiza el repintado, del bitmap de fondo
    * y de los elementos geomtricos
    * @param g Graphics
    */

   
   public void paint(Graphics g)
    {
     int i,x0,y0,x1,y1;
     paintComponent(g);
     g.setColor(colorFondo);g.fillRect(0,0,w,h);
     if (backGround!=null && verBitmap) backGround.paintIcon(this,g,0,0);
    
     g.setColor(colorPoligono);
     for (i=0;i<Poligonos.size() && verPoligonos;i++)
      {
       Vector poli=(Vector)Poligonos.elementAt(i);
       int xpoint[]=new int[poli.size()/2];
       int ypoint[]=new int[poli.size()/2];
       for (int j=0;j<poli.size();j+=2)
        {
         xpoint[j/2]=getZoomValue( ((Integer)poli.elementAt(j)).intValue() );
         ypoint[j/2]=getZoomValue( ((Integer)poli.elementAt(j+1)).intValue() );
        }

      g.drawPolygon(xpoint,ypoint,poli.size()/2);
       if (resaltaPoligonos)
           {
            for (int j=0;j<poli.size()/2;j++) xpoint[j]++;
            g.drawPolygon(xpoint,ypoint,poli.size()/2);
            for (int j=0;j<poli.size()/2;j++) { ypoint[j]++; xpoint[j]--;}
            g.drawPolygon(xpoint,ypoint,poli.size()/2);
           }
      }
      if (verEdges)
        {
        g.setColor(colorEdges);
        for (i=0;i<Edges.size();i++)
          {
           Vector edg=(Vector)Edges.elementAt(i);
           int xpoint[]=new int[edg.size()/2];
           int ypoint[]=new int[edg.size()/2];
           for (int j=0;j<edg.size();j+=2)
              {
               xpoint[j/2]=getZoomValue( ((Integer)edg.elementAt(j)).intValue() );
               ypoint[j/2]=getZoomValue( ((Integer)edg.elementAt(j+1)).intValue() );
              }
           for (int j=0;j<edg.size()/2;j++)
            {
            if (resaltaEdges) g.fillOval(xpoint[j]-2,ypoint[j]-2,4,4);
            else g.fillOval(xpoint[j],ypoint[j],1,1);
            }
          }
        }  
      
     g.setColor(colorLinea);
     for (i=0;i<Segmentos.size() && verSegmentos;i+=4)
      {
       x0=getZoomValue( ((Integer)Segmentos.elementAt(i)).intValue() );
       y0=getZoomValue( ((Integer)Segmentos.elementAt(i+1)).intValue() );
       x1=getZoomValue( ((Integer)Segmentos.elementAt(i+2)).intValue() );
       y1=getZoomValue( ((Integer)Segmentos.elementAt(i+3)).intValue() );
       g.drawLine(x0,y0,x1,y1);  
       if (resaltaSegmentos) 
          {
           g.drawLine(x0+1,y0,x1+1,y1);
           g.drawLine(x0,y0+1,x1,y1+1);
          }
      }
     g.setColor(colorLineaActual);
     if (arrastrando && accion==0) 
        { 
          if (ultimoX!=-1 || modo==SEG) 
          g.drawLine(xini,yini,xfin,yfin);
          if ((resaltaSegmentos && modo==SEG) ||
             (resaltaPoligonos && modo==POLY && ultimoX!=-1))
           {
            g.drawLine(xini+1,yini,xfin+1,yfin);
            g.drawLine(xini,yini+1,xfin,yfin+1);
           }
        }
     g.setColor(colorPunto);
     for (i=0;i<Puntos.size() && verPuntos;i+=2)
      {
       int xp=getZoomValue( ((Integer)Puntos.elementAt(i)).intValue() );
       int yp=getZoomValue( ((Integer)Puntos.elementAt(i+1)).intValue() );
       if (resaltaPuntos) g.fillOval(xp-2,yp-2,4,4);
       else g.fillOval(xp,yp,1,1);
      }
     g.setColor(colorPoligonoActual);
     for (i=0;i<PoligonoActual.size()-2;i+=2)
      {
       x0=getZoomValue( ((Integer)PoligonoActual.elementAt(i)).intValue() ); 
       y0=getZoomValue( ((Integer)PoligonoActual.elementAt(i+1)).intValue() );
       x1=getZoomValue( ((Integer)PoligonoActual.elementAt(i+2)).intValue() );
       y1=getZoomValue( ((Integer)PoligonoActual.elementAt(i+3)).intValue() );
       g.drawLine(x0,y0,x1,y1);  
       if (resaltaPoligonos)
           {
            g.drawLine(x0+1,y0,x1+1,y1);
            g.drawLine(x0,y0+1,x1,y1+1);
           }
      }
     if (estadoGeo!=0 && accion==1 && modo==SEG && verSegmentos)
      {
       if (x0Sel!=-1)
        {
         g.setColor(colorLineaActual);
         g.drawLine(x0Sel,y0Sel,x1Sel,y1Sel);
         g.drawLine(x0Sel+1,y0Sel,x1Sel+1,y1Sel);
         g.drawLine(x0Sel,y0Sel+1,x1Sel,y1Sel+1);
        }
      }
     if (estadoGeo!=0 && accion==1 && modo==PUNTO && verPuntos)
      {
       if (x0Sel!=-1)
        {
         g.setColor(colorLineaActual);
         g.drawOval(x0Sel-5,y0Sel-5,10,10);
        }
      }
    }
  }