import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.util.Vector;
import java.text.NumberFormat;
import jip.*;
import CanvasGeo;

/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 * Clase que contiene la informacin sobre los elementos
	 * del progra, desde la posicin del cursor, su valor, banda y
	 * frame en el que nos encontramos etc
   */


public class InfoPanel extends JPanel {
	 /** El Canvas */
   CanvasGeo   canvas;
   /** Secuencia */
   JIPSequence seq;
   /** Nmero de Segmenos */
   int         nSegment = 0;
   /** X Inicial */
   int         xini;
   /** Y Inicial */
   int         yini;
   /** Etiqueta dePosicin */
   JLabel      Posicion;
   /** Etiqueta de Valor Actual */
   JLabel      valor;
   /** Etiqueta de Segmentos */
   JLabel      Segmentos;
   /** Etiqueta de Puntos */
   JLabel      Puntos;
   /** Etiqueta de Geometra */
   JLabel      Geometria;
   /** Etiqueta de Polgonos */
   JLabel      Poligonos;
   /** Etiqueta de la longitud Actual */
   JLabel      longitud;
   /** Nombre de la Secuencia */
   JLabel       nombreSec;
   /** Etiqueta de tamao del Frame */
   JLabel       tamFrame;
   /** Etiqueta de Inicio de Seleccin */
   JLabel      iniSel;
   /** Etiqueta de Fin de Seleccin */
   JLabel       finSel;
   /** Etiqueta de Longitud del Segmento */
   JLabel       longSel;
   /** Etiqueta del tipo de Seleccin */
   JLabel       tipoSel;
   /** Cadena que indica las unidades */
   String      unidad;
   /** Escala */
   float       escala = 1;
   /** Desplegable del Frame Seleccionado */
   JComboBox   frameSel;
   /** Desplegable de la Banda Seleccionada */
   JComboBox   bandSel;
   /** Formato de Nmero*/ 
   NumberFormat nf;

		/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Constructor de la clase. Aqui se crea todo el panel de informacin
   * que veremos en la parte izquierda de la ventana del programa principal
   * @param c CanvasGeomtrico
	 */

   public InfoPanel (CanvasGeo c) {
      canvas = c;
      nf=NumberFormat.getInstance();
      nf.setMaximumFractionDigits(4);
      
      setMaximumSize(new Dimension(150, 600));
      setBorder(BorderFactory.createEtchedBorder());

      unidad    = new String("Pixels");
      nombreSec = new JLabel("Nombre sec.: ");
      tamFrame  = new JLabel("Tamao frame:");
      Posicion  = new JLabel("Posicion    :");
      valor     = new JLabel("Valor:");
      Segmentos = new JLabel("NSegmentos :");
      Puntos    = new JLabel("N Puntos :");
      Poligonos = new JLabel("N Poligonos :");
      longitud  = new JLabel("Longitud:");
      Geometria = new JLabel("Geometria:");
      

      setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
      add(nombreSec);
      add(tamFrame);
      //add(new JLabel("_______"));
      add(Posicion);
      add(valor);
      add(Segmentos);
      add(Puntos);
      add(Poligonos);
      add(longitud);
      add(Geometria);

      JRadioButton boton;
      JPanel       auxPanel = new JPanel();

      auxPanel.setLayout(new BoxLayout(auxPanel, BoxLayout.Y_AXIS));
      auxPanel.setBorder(BorderFactory.createTitledBorder("Modo"));

      ButtonGroup geoTipo = new ButtonGroup();

      boton = new JRadioButton("Segmentos", true);

      boton.addActionListener(canvas);
      auxPanel.add(boton);
      geoTipo.add(boton);

      boton = new JRadioButton("Puntos");

      boton.addActionListener(canvas);
      auxPanel.add(boton);
      geoTipo.add(boton);

      boton = new JRadioButton("Poligonos");

      boton.addActionListener(canvas);
      auxPanel.add(boton);
      geoTipo.add(boton);
      add(auxPanel);

      JComboBox accionSel = new JComboBox();

      accionSel.addItem("Aadir");
      accionSel.addItem("Seleccionar");
      accionSel.setBorder(BorderFactory.createTitledBorder("Accion"));
      accionSel.setSelectedIndex(0);
      accionSel.addActionListener(canvas);
      add(accionSel);

      Vector comp = new Vector();

      bandSel = new JComboBox();

      bandSel.addItem("[ No hay secuencia ]");
      bandSel.setBorder(BorderFactory.createTitledBorder("Banda"));

      Vector comp2 = new Vector();

      frameSel = new JComboBox();

      frameSel.addItem("[ No hay secuencia ]");
      frameSel.setBorder(BorderFactory.createTitledBorder("Frame"));
      bandSel.addActionListener(canvas);
      frameSel.addActionListener(canvas);
      add(bandSel);
      add(frameSel);

      auxPanel = new JPanel();

      auxPanel.setLayout(new BoxLayout(auxPanel, BoxLayout.Y_AXIS));
      auxPanel.setBorder(BorderFactory.createTitledBorder("Seleccion"));

      tipoSel = new JLabel(" ");

      auxPanel.add(tipoSel);

      iniSel = new JLabel(" ");

      auxPanel.add(iniSel);

      finSel = new JLabel(" ");

      auxPanel.add(finSel);

      longSel = new JLabel(" ");

      auxPanel.add(longSel);
      add(auxPanel);
      UpdateSel(-1, -1, -1, -1, "[sin seleccion]");
   }

		/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Mtodo que cambia la escala actual por la que recibe como parmetro
   * @param esc Nuevo valor de la escala
   */


   public void CambioEscala (float esc)
   {
      escala = esc;
   }

	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Mtodo que cambia las unidades actuales por las recibe como parmetro
   * @param uni Nuevo valor de las unidades
   */


   public void CambioUnidad (String uni)
   {
      if (uni.length() > 15)
      {
         uni = uni.substring(0, 15);
      }

      unidad = uni;
   }
	
	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Mtodo que coloca los la informacin de los valores de la nueva
   * secuencia en el panel
   * @param s Nueva secuencia
   */

   public void AsociaSecuencia (JIPSequence s)
   {
      seq = s;

      frameSel.removeAllItems();
      bandSel.removeAllItems();
      Vector v;
      if (seq == null)
      {
         frameSel.addItem("[ No hay secuencia ]");
         bandSel.addItem("[ No hay secuencia ]");
         nombreSec.setText("Nombre sec.: ");
         return;
      }
      
      for (int i = 0; i < seq.getNumFrames(); i++)
      {
         String tipo = new String();
         
         switch (seq.getFrame(i).getType())
         {

            case JIP.tBIT :
               tipo = "BIT  ";
               break;

            case JIP.tBYTE :
               tipo = "BYTE ";
               break;

            case JIP.tWORD :
               tipo = "WORD ";
               break;

            case JIP.tCOLOR :
               tipo = "COLOR";
               break;

            case JIP.tREAL :
               tipo = "REAL ";
               break;

            case JIP.tPOINT :
               tipo   = "POINT";
               break;

            case JIP.tSEGMENT :
               tipo   = "SEGMENT";
               break;

            case JIP.tPOLY :
               tipo   = "POLY";
               break;

            case JIP.tEDGES :
               tipo   = "EDGES";
               break;
         }

         frameSel.addItem(i + ":" + tipo + ":" + seq.getFrame(i).getName());
      }

      bandSel.removeAllItems();

      if (seq.getFrame(0).getType() == JIP.tCOLOR)
      {
         bandSel.addItem("COLOR-Bandas RGB");
      }
      else
      {
         for (int j = 0; j < seq.getFrame(0).getNumBands(); j++)
         {
            bandSel.addItem("Banda " + j);
         }
      }

      nombreSec.setText("Nombre sec.: " + s.getName());
   }
   
   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Mtodo que actualiza el estado de la geometra, que puede estar
   * activada o desactivada
   * @param geoEst Valor de la geometra (activada/desactivada)
   */


   public void UpdateGeo (int geoEst)
   {
      if (geoEst == 1)
      {   // geometria activada
         Geometria.setText("Geometra: Activada");
      }
      else
      {
         Geometria.setText("Geometra: Desactivada");
      }
   }

   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Mtodo que actualiza el valor de las bandas
   * @param img Nueva Imagen
   * @param n Nmero de bandas
   */


   public void BandasFrame (JIPImage img, int n)
   {
      bandSel.removeAllItems();

      if (n == -1)
      {
         bandSel.addItem("COLOR-Bandas RGB");
      }
      else
      {
         for (int i = 0; i < n; i++)
         {
            bandSel.addItem("Banda " + i);
         }
      }

      tamFrame.setText("Tamao frame: " + img.getWidth() + "x"
                       + img.getHeight());
   }

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Mtodo que actualiza la informacin del panel, como el ancho, 
   * el alto, numero de segmentos, imagen, bandas, etc..
   * @param w Ancho
   * @param h Alto
   * @param x X actual
	 * @param y Y actual
	 * @param numSeg Nmero de Segmentos
	 * @param numPoint Nmero de Puntos
	 * @param numPoly  Nmero de Polgonos
	 * @param xini X Inicial
	 * @param yini Y Inicial
	 * @param xfin X Final
	 * @param yfin Y Final
	 * @param img Imagen
	 * @param b Nmero de bandas
   */


   public void UpdateInfo (int w, int h, int x, int y, int numSeg,
                           int numPoint, int numPoly, int xini, int yini,
                           int xfin, int yfin, JIPImage img, int b)
   {
      if ((x <= w) && (x > 0) && (y <= h) && (y > 0))
      {
         Posicion.setText("Posicion:(" + x + "," + y + ")");
         if (img==null) valor.setText("Valor: <-1>");
					else if (img.getType()==JIP.tREAL) valor.setText("Valor: <"+img.getPixelFlo(b,x,y)+">");
					else if (img.getType()==JIP.tCOLOR) valor.setText("Valor: <"+img.getPixelRed(x,y)+
										","+img.getPixelGreen(x,y)+","+img.getPixelBlue(x,y)+">");
					else valor.setText("Valor: <"+img.getPixel(b,x,y)+">");
      }
      else
      {
         Posicion.setText("Posicion: ( OUT )");
         valor.setText("Valor: ( OUT )");
      }

      Segmentos.setText("NSegmentos :" + numSeg);
      Puntos.setText("N Puntos :" + numPoint);
      Poligonos.setText("N Poligonos :" + numPoly);

      String longS =
         nf.format((escala * Math.sqrt(
         Math.pow(xini - xfin, 2) + Math.pow(yini - yfin, 2))));

      longitud.setText(longS+ " " + unidad);
   }

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Mtodo que actualiza el apartado del panel correspondiente a la
   * seleccin.
   * @param x0 X Inicial
   * @param y0 Y Inicial
   * @param x1 X Final
	 * @param y1 Y Final
	 * @param tipo Tipo
	 */



   public void UpdateSel (int x0, int y0, int x1, int y1, String tipo)
   {
      tipoSel.setText("Tipo : " + tipo);
      iniSel.setText("Inicio : (" + x0 + "," + y0 + ")");
      finSel.setText("Fin : (" + x1 + "," + y1 + ")");

      String longS =
         nf.format(escala * Math.sqrt(
         Math.pow(x0 - x1, 2) + Math.pow(y0 - y1, 2)));

      longSel.setText(longS+ " " + unidad);
   }

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Mtodo que selecciona un frame, cuyo nmero pasamos por parmetro
   * @param nframe Nmero de Frame
	 */

   public void SetFrame(int nFrame)   {
    frameSel.setSelectedIndex(nFrame);
   }
}