

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 *   Realiza un filtro de extensiones para los cuadros de dialogo de abrir y cerrar
	 *ficheros desde el entorno grfico del programa. En esta clase se realizan
	 *los filtros para obtener solo jip.
   */

public class JIPImageFilter
   extends FileFilter
{
	/** Cadena de texto para jip*/
   final static String jip = "jip";

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *  Indica si se acepta el fichero, es decir, si es un directorio, o su extensin es
   * jip, devolver TRUE.
   * @param f Fichero a analizar
   * @return TRUE si el fichero es un directorio o su extension es jip. FALSE
   * en otro caso.
   */



   public boolean accept (File f)
   {
      if (f.isDirectory())
      {
         return true;
      }

      String s = f.getName();
      int    i = s.lastIndexOf('.');

      if ((i > 0) && (i < s.length() - 1))
      {
         String extension = s.substring(i + 1).toLowerCase();

         if (jip.equals(extension))
         {
            return true;
         }
         else
         {
            return false;
         }
      }

      return false;
   }

  
	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 * Descripcion del filtro
	 * @return Devuelve una cadena con la descripcin del filtro.
	 */
   
   public String getDescription ()
   {
      return "Secuencias JIP";
   }
}


/*------ Formatted by Jindent 3.0 trial --- http://www.jindent.de ------*/