import jip.*;

import java.awt.*;

/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 *  Convierte una imagen en formato GIF o JPEG a formato JIP.
	 * Esta clase se llama desde lnea de comandos.Forma de uso: java ToJip <gif_or_jpeg_file>;
   */


public class ToJip {
	
	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * 	Mtodo que contiene el main de la clase (para ejecutarlo desde lnea de comandos)
   * @param Imagen Imagen de tipo GIF o JPG
   */

    public static void main(String[] args) {
    			
    	//Comprueba el argumento
    	if(args.length!=1) error("Numero de argumentos incorrecto.");
		if(args[0].equals("-help")) help();
		if(!(new java.io.File(args[0])).isFile())
    	    error("El fichero '"+args[0]+"' NO EXISTE");

    	//Carga la imagen fuente
    	Image awtimg=JIPToolkit.getAWTImage(args[0]);
    	if(awtimg==null) error("Imposible cargar GIF o JPEG imagen: "+args[0]);    	
    	
    	//Obtiene nombre de la imagen (sin extiension)
    	String name=null;
    	if(args[0].lastIndexOf(".")==-1) name=args[0];
    	else name=args[0].substring(0,args[0].lastIndexOf("."));
    	
    	//Transforma la imagen y crea una secuencia con ella
    	JIPImage img=JIPToolkit.getColorImage(awtimg);    	
    	img.setName(name);
    	JIPSequence seq=new JIPSequence(img);
    	seq.setName(name);
    	
    	//Salva la imagen
    	JIPToolkit.saveSeqIntoFile(seq,name+".jip");
    	System.exit(0);

    }

	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *    Saca un mensaje de error por la salida de error.
   * @param str Cadena que contiene el mensaje de error
	 */

    static void error(String str) {
		System.err.println("*** ERROR: "+str+" ***");
		System.err.println("");
		help();
    }

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *    Saca por pantalla la ayuda del comando
	 */


    static void help() {
		System.out.println(
			"ToJip: Convierte una imagen en formato GIF o JPEG a formato JIP.");
		System.out.println("Forma de uso: java ToJip <gif_or_jpeg_file>");
		System.out.println("");		
		System.exit(0);
    }
}