import jip.*;

/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 *   Convierte una secuencia en formato JIP a imagenes en formato TGA (Targa).
	 * Esta clase se llama desde lnea de comandos.Forma de uso: java ToTga <jip_file>;
   */


public class ToTga {

	/**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * 	Mtodo que contiene el main de la clase (para ejecutarlo desde lnea de comandos)
   * @param Imagen Imagen de tipo JIP
   */

    public static void main(String[] args) {
    			
    	//Comprueba el argumento
    	if(args.length!=1) error("Numero de argumentos incorrecto.");
		if(args[0].equals("-help")) help();
		if(!(new java.io.File(args[0])).isFile())
    	    error("El fichero '"+args[0]+"' NO EXISTE");

    	//Carga la imagen fuente
    	JIPSequence seq=JIPToolkit.getSeqFromFile(args[0]);
    	if(seq==null) error("Imposible cargar secuencia JIP: "+args[0]);    	
   	
    	//Obtiene nombre de la imagen (sin extension)
    	String name=null;
    	if(args[0].lastIndexOf(".")==-1) name=args[0];
    	else name=args[0].substring(0,args[0].lastIndexOf("."));
    	
    	//Convierte las imagenes de la secuencia
    	JIPToolkit.saveSeqIntoTga(seq,name+".tga");
    	
    	System.exit(0);

    }

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *    Saca un mensaje de error por la salida de error.
   * @param str Cadena que contiene el mensaje de error
	 */

    static void error(String str) {
		System.err.println("*** ERROR: "+str+" ***");
		System.err.println("");
		help();
    }

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *    Saca por pantalla la ayuda del comando
	 */

    static void help() {
		System.out.println(
			"ToTga: Convierte una secuencia en formato JIP a imagenes en formato TGA (Targa)");
		System.out.println("Forma de uso: java ToTga <jip_file>");
		System.out.println("");		
		System.exit(0);
    }

}