import javax.swing.*;          
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.io.*;
import java.util.zip.*;
import java.lang.Runtime;

import jip.*;
import jiputil.JIPFunctionDialogG;    
import jiputil.JIPFunctionList;
import CanvasGeo;
import InfoPanel;
import BarraMenuViewerG;
import Dialogo;

	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
	 *   Clase principal del programa, desde la cual se inicializa. Desde aqui se cargan todos 
	 * los menus, y se implementa el ActionListener del programa. Se manejan los eventos correspondientes
	 * a cada elemento del men desplegable superior de la ventana principal del programa.
	 * Esta clase contiene el main principal que lanza el programa, as como el contenedor de la secuencia,
	 * panel de informacin etc...
   */



public class ViewerG extends JFrame implements ActionListener 
  {
    private JLabel label;
    /** Contenedor secuencia*/
    CanvasGeo canvas;         
    /** Scroll pane del canvas */
    JScrollPane canvasScr;
    /** Ultimo directorio accedido en carga */
    String ultimoDirectorio;    
    /** Panel de informacin */
    InfoPanel info;            
    /** Lista de funciones disponibles */
    JIPFunctionList funclist; 
    /** Ultima accin (para undo) */
    JLabel ultimaAccion;        
    /** Secuencia para undo */
    JIPSequence undoSeq;      
    /** Contenedor base */
    JPanel pane;          
      
   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Constructor de la clase. Aqui se crea la lista de funciones, la barra de men,
   * el panel de datos, etc...
   */

    public ViewerG() 
      {
       super("ViewerG");
       funclist=new JIPFunctionList();
       ultimaAccion=new JLabel("       ninguna");
       BarraMenuViewerG menuBar=
             new BarraMenuViewerG(this,funclist,ultimaAccion);
       setJMenuBar(menuBar);

       JPanel pane = new JPanel();
       ultimoDirectorio=null;    
   
       canvas=new CanvasGeo(400,300);
       canvasScr=new JScrollPane(
                 canvas,
                 ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
                 ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
       
       canvasScr.setViewportBorder(new BevelBorder(BevelBorder.RAISED));
       info=new InfoPanel(canvas);
       canvas.AsociaInfo(info);
       pane.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
       pane.setLayout(new BoxLayout(pane,BoxLayout.X_AXIS));

       pane.add(canvasScr);
       pane.add(info);
       setContentPane(pane);
       setIconImage(new Icono("/icons/vg.gif").getIcono().getImage());
     
    }
 
   /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   * Manejador de eventos de la clase. Desde aqui se controla el contenido de los mens y
   * que hacer cuando se pulsa un elemento del men desplegable superior de la ventana
   * principal.
   * @param e Accion que se ha producido
   */
   public void actionPerformed(ActionEvent e) 
      {
       if (e.getActionCommand().equals("Nuevo"))
        {
         String tamX,tamY;
         int w=-1,h=-1;
         JOptionPane askTam=new JOptionPane();
         tamX=askTam.showInputDialog(this,"Introduzca anchura");
         tamY=askTam.showInputDialog(this,"Introduzca altura");
         try{
           if (tamX.length()>0) 
             w=new Integer(-1).decode(tamX).intValue();
           if (tamY.length()>0) 
             h=new Integer(-1).decode(tamY).intValue();
            }catch(Exception err) {}

         //NUEVO DOMINGO
         if (w>0 && h>0) {
         			//System.out.println(w+","+h);
         			canvas.VaciarTodos();
         			canvas.SetSecuencia(null);
		          if (w>0 && h>0) canvas.Nuevo(w,h,null);        
      	      ultimaAccion.setText("       ninguna"); 
         			undoSeq=null;
         			setTitle("ViewerG - No hay secuencia cargada");
         			ultimoDirectorio=null;
        	}
        }
        
       if (e.getActionCommand().equals("Abrir Imagen"))
        {
         JFileChooser abreFich = new JFileChooser();
         if (ultimoDirectorio!=null)
         abreFich.setCurrentDirectory(new File(ultimoDirectorio));
         else abreFich.setCurrentDirectory(new File("."));
         abreFich.setFileFilter(new ALLImageFilter());  
         int returnVal = abreFich.showOpenDialog(this);
         if (returnVal == abreFich.APPROVE_OPTION) 
          {
           canvas.VaciarTodos();
           File fich = abreFich.getSelectedFile();
           ultimoDirectorio=fich.getAbsolutePath();
           canvas.PonBitmap(fich.getAbsolutePath());
					 String nSeq=fich.getName();
					 nSeq=ultimoDirectorio.substring(ultimoDirectorio.lastIndexOf("\\")+1,ultimoDirectorio.lastIndexOf("."));	
		       canvas.NombreSecuencia(nSeq);
           setTitle("ViewerG - Secuencia: ["+canvas.NombreSecuencia()+"] Fichero: ["+ultimoDirectorio+"]");
           ultimaAccion.setText("       ninguna"); 
           undoSeq=new JIPSequence(canvas.GetSecuencia());
          }
        }
                
       if (e.getActionCommand().equals("Abrir JIP"))
        {
         JFileChooser abreFich = new JFileChooser();
         if (ultimoDirectorio!=null)
         abreFich.setCurrentDirectory(new File(ultimoDirectorio));
         else abreFich.setCurrentDirectory(new File("."));
         abreFich.setFileFilter(new JIPImageFilter());
         int returnVal = abreFich.showOpenDialog(this);
         if (returnVal == abreFich.APPROVE_OPTION) 
          {
           canvas.VaciarTodos();
           File fich = abreFich.getSelectedFile();
           ultimoDirectorio=fich.getAbsolutePath();
           canvas.CargaSecuencia(fich.getAbsolutePath());
           ultimaAccion.setText("       ninguna"); 
           undoSeq=new JIPSequence(canvas.GetSecuencia());
           setTitle("ViewerG - Secuencia: ["+canvas.NombreSecuencia()+"] Fichero: ["+ultimoDirectorio+"]");
          }
        }
   
        if (e.getActionCommand().equals("Abrir JIPZ"))
        {
         JFileChooser abreFich = new JFileChooser();
         if (ultimoDirectorio!=null)
         abreFich.setCurrentDirectory(new File(ultimoDirectorio));
         else abreFich.setCurrentDirectory(new File("."));
         abreFich.setFileFilter(new JIPZImageFilter());
         int returnVal = abreFich.showOpenDialog(this);
         if (returnVal == abreFich.APPROVE_OPTION) 
          {
           canvas.VaciarTodos();
           try{
             File fich = abreFich.getSelectedFile();
             ultimoDirectorio=fich.getAbsolutePath();
             String dir2=fich.getPath();
             BufferedInputStream fi = new BufferedInputStream (new FileInputStream(ultimoDirectorio));
             CheckedInputStream csumi = new CheckedInputStream(fi, new CRC32());
             ZipInputStream in2 = new ZipInputStream(new BufferedInputStream(csumi));
             ZipEntry ze=in2.getNextEntry(); 
             String filejip=ultimoDirectorio.substring(0,ultimoDirectorio.lastIndexOf("."))+".jip";
             BufferedOutputStream out = new BufferedOutputStream(
               new FileOutputStream(filejip));
                        
             System.out.println("Descomprimiendo...");        
             long t0,t1;
             byte b1[]=new byte[1048576];  // reservo un mega
             t0 = System.currentTimeMillis();  // tiempo inicial
             int tope=0,ind=0;
             while((tope=in2.read(b1,0,1048576))!=-1){
               byte sol[]=new byte[tope];
               for(ind=0;ind<tope;ind++)  // copia al array solucion
                 sol[ind]=b1[ind];
               out.write(sol);            // grabar al fichero
             }
             out.close();
             t1 = System.currentTimeMillis();  // tiempo final
             System.out.println("Proceso de descompresion terminado en: "+(double)(t1-t0)/1000.0+" seg.");
             fich=new File(filejip);
             canvas.CargaSecuencia(fich.getAbsolutePath());
	           setTitle("ViewerG - Secuencia: ["+canvas.NombreSecuencia()+"] Fichero: ["+ultimoDirectorio+"]");
             ultimaAccion.setText("       ninguna"); 
             undoSeq=new JIPSequence(canvas.GetSecuencia());

           }catch(Exception es) { es.printStackTrace(); }
          }
        }

          if (e.getActionCommand().equals("Guardar JIP"))
        {
        if (canvas.secuencia==null) return;
        String path,nfile;
        if (ultimoDirectorio==null) { 
          path=".\\"; 
          ultimoDirectorio=path+canvas.secuencia.getName()+".jip";
        }
        else if(!ultimoDirectorio.toLowerCase().endsWith(".jip")) 
          {
          new Dialogo(this).Informacion("La secuencia se guardar en formato JIP","ATENCION");
           ultimoDirectorio=ultimoDirectorio.substring(0,ultimoDirectorio.lastIndexOf("."))+".jip";
          }              
        //modif=false;
        setTitle("ViewerG - ["+ultimoDirectorio+"] guardando...");
        JIPToolkit.saveSeqIntoFile(canvas.secuencia,ultimoDirectorio);
        setTitle("ViewerG - Secuencia: ["+canvas.NombreSecuencia()+"] Fichero: ["+ultimoDirectorio+"]");
    } 
       
      if (e.getActionCommand().equals("Guardar como"))
        {
        if (canvas.secuencia==null) return;          
        JFileChooser abreFich = new JFileChooser();
        String path,nfile;
        // por si es nuevo
        if (ultimoDirectorio==null) { 
          path=".\\"; 
          nfile=canvas.secuencia.getName();
        }
        // si ya hay uno
        else {
          
          path=ultimoDirectorio.substring(0,ultimoDirectorio.lastIndexOf("\\")+1);
          
          if (ultimoDirectorio.lastIndexOf(".")!=-1)
               nfile=ultimoDirectorio.substring(ultimoDirectorio.lastIndexOf("\\")+1,ultimoDirectorio.lastIndexOf("."));
          else nfile=ultimoDirectorio.substring(ultimoDirectorio.lastIndexOf("\\")+1,ultimoDirectorio.length());
          
        }
        if (ultimoDirectorio!=null){
            abreFich.setCurrentDirectory(new File(path));
            abreFich.setSelectedFile(new File(nfile));
        }
        else {
           abreFich.setCurrentDirectory(new File("."));
           abreFich.setSelectedFile(new File("[UNNAMED]"));
        }
        int returnVal = abreFich.showSaveDialog(this);
        if (returnVal == abreFich.APPROVE_OPTION) 
          {
              File fich = abreFich.getSelectedFile();
              ultimoDirectorio=fich.getAbsolutePath();
              if(ultimoDirectorio.toLowerCase().endsWith(".jip")
                  || ultimoDirectorio.toLowerCase().endsWith(".jipz")) {
                          
                 if(!ultimoDirectorio.toLowerCase().endsWith(".jipz")) {                   
                   ultimoDirectorio=ultimoDirectorio.substring(0,ultimoDirectorio.length());
                   setTitle("ViewerG - ["+ultimoDirectorio+"] guardando...");
                   JIPToolkit.saveSeqIntoFile(canvas.secuencia,ultimoDirectorio);
		               setTitle("ViewerG - Secuencia: ["+canvas.NombreSecuencia()+"] Fichero: ["+ultimoDirectorio+"]");

                 }
                 else {                    
                    ultimoDirectorio=ultimoDirectorio.substring(0,ultimoDirectorio.length());
                    setTitle("ViewerG - ["+ultimoDirectorio+"] guardando...");                     
                    path=ultimoDirectorio.substring(0,ultimoDirectorio.lastIndexOf("\\")+1);                     
                    if (ultimoDirectorio.lastIndexOf(".")!=-1)
	               			nfile=ultimoDirectorio.substring(ultimoDirectorio.lastIndexOf("\\")+1,ultimoDirectorio.lastIndexOf("."));
	               	  else 
						          nfile=ultimoDirectorio.substring(ultimoDirectorio.lastIndexOf("\\")+1,ultimoDirectorio.length());
                    JIPToolkit.saveSeqIntoFileZip(canvas.secuencia,path,nfile);
                    setTitle("ViewerG - Secuencia: ["+canvas.NombreSecuencia()+"] Fichero: ["+ultimoDirectorio+"]");
                 }
              }
              else {
                setTitle("ViewerG - ["+ultimoDirectorio+".jip] guardando...");
                JIPToolkit.saveSeqIntoFile(canvas.secuencia,ultimoDirectorio+".jip");
                ultimoDirectorio=ultimoDirectorio.substring(0,ultimoDirectorio.length())+".jip";
                setTitle("ViewerG - Secuencia: ["+canvas.NombreSecuencia()+"] Fichero: ["+ultimoDirectorio+"]");
              }
          }
        
    } 

      
   if (e.getActionCommand().equals("Guardar JIPZ"))
        {
        if (canvas.secuencia==null) return;  
        String path,nfile;        
        if (ultimoDirectorio==null) { 
          path=".\\"; 
          ultimoDirectorio=path+canvas.secuencia.getName()+".jipz";
        }       
        else if(!ultimoDirectorio.toLowerCase().endsWith(".jipz")) 
        {
           new Dialogo(this).
           Informacion("La secuencia se guardar en formato JIPZ","ATENCION");
           ultimoDirectorio=ultimoDirectorio.substring(0,ultimoDirectorio.lastIndexOf("."))+".jipz";        
        }              
        
        path=ultimoDirectorio.substring(0,ultimoDirectorio.lastIndexOf("\\")+1);
        nfile=ultimoDirectorio.substring(ultimoDirectorio.lastIndexOf("\\")+1,ultimoDirectorio.lastIndexOf("."));
        
        setTitle("ViewerG - ["+ultimoDirectorio+"] guardando...");
        JIPToolkit.saveSeqIntoFileZip(canvas.secuencia,path,nfile);
        setTitle("ViewerG - Secuencia: ["+canvas.NombreSecuencia()+"] Fichero: ["+ultimoDirectorio+"]");
    } 
    
    if (e.getActionCommand().equals("Salir")){
        
     int salir=new Dialogo(this).Confirmar("Salir de la Aplicacion","SALIR");   
     
     if (salir==0)    // Salimos de la aplicacion
       System.exit(0);   
     
    }

        
       if (e.getActionCommand().equals("Color Fondo"))
        {
          canvas.ColorFondo(new JColorChooser().showDialog(this,"Selecciona Color",new Color(255,255,255)));
          canvasScr.repaint();
        }

       if (e.getActionCommand().equals("Color Panel"))
        {
          canvas.ColorFondoScroll(new JColorChooser().showDialog(this,"Selecciona Color",new Color(255,255,255)));
          canvasScr.repaint();
        }

       if (e.getActionCommand().equals("Color Segmentos"))
        {
          canvas.ColorLinea(new JColorChooser().showDialog(this,"Selecciona Color",new Color(255,255,255)));
          canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Color Segmento en Curso"))
        {
          canvas.ColorLineaActual(new JColorChooser().showDialog(this,"Selecciona Color",new Color(255,255,255)));
        }
       if (e.getActionCommand().equals("Color Punto"))
        {
          canvas.ColorPunto(new JColorChooser().showDialog(this,"Selecciona Color",new Color(255,255,255)));
          canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Color Poligono"))
        {
          canvas.ColorPoligono(new JColorChooser().showDialog(this,"Selecciona Color",new Color(255,255,255)));
          canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Color Poligono en Curso"))
        {
          canvas.ColorPoligonoActual(new JColorChooser().showDialog(this,"Selecciona Color",new Color(255,255,255)));
          canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Color Edges"))
        {
          canvas.ColorEdges(new JColorChooser().showDialog(this,"Selecciona Color",new Color(255,255,255)));
          canvasScr.repaint();
        }
        
       if (e.getActionCommand().equals("Resaltar Segmentos"))
        {
         canvas.ResaltaSegmentos(((JCheckBoxMenuItem)e.getSource()).getState());
         canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Resaltar Puntos"))
        {
         canvas.ResaltaPuntos(((JCheckBoxMenuItem)e.getSource()).getState());
         canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Resaltar Poligonos"))
        {
         canvas.ResaltaPoligonos(((JCheckBoxMenuItem)e.getSource()).getState());
         canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Resaltar Edges"))
        {
         canvas.ResaltaEdges(((JCheckBoxMenuItem)e.getSource()).getState());
         canvasScr.repaint();
        }
       
       if (e.getActionCommand().equals("Ver Bitmap"))
        {
         canvas.VerBitmap(((JCheckBoxMenuItem)e.getSource()).getState());
         canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Ver Segmentos"))
        {
         canvas.VerSegmentos(((JCheckBoxMenuItem)e.getSource()).getState());
         canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Ver Puntos"))
        {
         canvas.VerPuntos(((JCheckBoxMenuItem)e.getSource()).getState());
         canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Ver Poligonos"))
        {
         canvas.VerPoligonos(((JCheckBoxMenuItem)e.getSource()).getState());
         canvasScr.repaint();
        }
       if (e.getActionCommand().equals("Ver Edges"))
        {
         canvas.VerEdges(((JCheckBoxMenuItem)e.getSource()).getState());
         canvasScr.repaint();
        }
                            

       if (e.getActionCommand().equals("Datos Segmentos"))
        {
          
          String cols[]={"Indice","Inicio X","Inicio Y","Fin X","Fin Y","Longitud"};
          Object [][]datos=canvas.DatosSegmentos();
          JTable tabla=new JTable(datos,cols);
          JDialog dialog=new JDialog(this,"Datos Segmentos",true);
          JScrollPane tablaScroll = new JScrollPane(tabla);
          tablaScroll.setVerticalScrollBarPolicy(
                      JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
          JPanel pan=new JPanel();
          pan.add(tablaScroll);
          dialog.setContentPane(pan);
          dialog.setSize(new Dimension(500,400));
          dialog.setResizable(false);
          dialog.setLocationRelativeTo(this);
          dialog.pack();
          dialog.setVisible(true);
        }
        
       if (e.getActionCommand().equals("Introducir factor de escala"))
        {
         JOptionPane askFactor=new JOptionPane();
         String esc=askFactor.showInputDialog(this,"Introduzca factor de escala");
         float f=-1f;
         try{
           if (esc.length()>0) 
             f=new Float(-1f).valueOf(esc).floatValue();
            }catch(Exception err) {}
         if (f!=-1) info.CambioEscala(f);
        }
       if (e.getActionCommand().equals("Escalar segun ultimo segmento"))
        {
         float longitud=canvas.LongitudUltimoSegmento();
         if (longitud==-1) return;
         JOptionPane askFactor=new JOptionPane();
         String esc=askFactor.showInputDialog(this,"Introduzca longitud ultimo segmento");
         float f=-1f;
         try{
           if (esc.length()>0) 
             f=new Float(-1f).valueOf(esc).floatValue();
            }catch(Exception err) {}
         if (f!=-1) info.CambioEscala((float)(f/longitud));
        }
       if (e.getActionCommand().equals("Escalar segun segmento seleccionado"))
        {
         float longitud=canvas.LongitudSegmentoSeleccionado();
         if (longitud==-1) return;
         JOptionPane askFactor=new JOptionPane();
         String esc=askFactor.showInputDialog(this,"Introduzca longitud del segmento seleccionado");
         float f=-1f;
         try{
           if (esc.length()>0) 
             f=new Float(-1f).valueOf(esc).floatValue();
            }catch(Exception err) {}
         if (f!=-1) info.CambioEscala((float)(f/longitud));
        }

       if (e.getActionCommand().equals("Escalar segun ultimos dos puntos"))
        {
         float longitud=canvas.DistanciaUltimosPuntos();
         if (longitud==-1) return;
         JOptionPane askFactor=new JOptionPane();
         String esc=askFactor.showInputDialog(this,"Introduzca distancia entre los puntos");
         float f=-1f;
         try{
           if (esc.length()>0) 
             f=new Float(-1f).valueOf(esc).floatValue();
            }catch(Exception err) {}
         if (f!=-1) info.CambioEscala((float)(f/longitud));
        }
       
       if (e.getActionCommand().equals("Unidades"))
        {
         info.CambioUnidad(new JOptionPane().showInputDialog(this,"Introduzca unidad de medida"));
        }
   
       if (e.getActionCommand().equals("Zoom"))
        {
         JOptionPane askFactor=new JOptionPane("Zoom");
         String factorS=askFactor.showInputDialog(this,"Introduzca porcentaje (>1)");
         int f=-1;
         try{
           if (factorS.length()>0)
              f=new Integer(-1).valueOf(factorS).intValue();
              undoSeq=new JIPSequence(canvas.GetSecuencia());
            }catch(Exception err) {}
         if (f>1) canvas.VentanaZoom(f);
        }
       
       if (e.getActionCommand().equals("Tamao original"))
        { 
         if (undoSeq!=null) 
           {
            canvas.SetSecuencia(canvas.GetSecuencia());
            canvas.QuitarVista();
            canvas.CambiaFrame(canvas.GetFrameNum()); 
           }
         else System.out.println("Error, no hay ninguna secuencia a restaurar.");
         ultimaAccion.setText("       ninguna"); 
         undoSeq=null;
        }


       if (e.getActionCommand().equals("Renombrar secuencia"))
        {
         if (canvas.GetSecuencia()==null) return;
         JOptionPane nombre=new JOptionPane("Renombrar Secuencia");
         String nombreS=nombre.showInputDialog(this,"Introduzca nuevo nombre :");
         canvas.NombreSecuencia(nombreS);
         setTitle("ViewerG - "+nombreS);
        }
       if (e.getActionCommand().equals("Renombrar frame"))
        {
         if (canvas.GetSecuencia()==null) return;
         JOptionPane nombre=new JOptionPane("Renombrar Frame");
         String nombreS=nombre.showInputDialog(this,"Introduzca nuevo nombre :");
         canvas.NombreFrame(nombreS);
        }
       if (e.getActionCommand().equals("Duplicar frame"))
        {
         if (canvas.GetSecuencia()==null) return;
         canvas.duplicaFrame();
        }
       if (e.getActionCommand().equals("Desde imagen"))
        {
         if (canvas.GetSecuencia()==null) return;
         JFileChooser abreFich = new JFileChooser();
         if (ultimoDirectorio!=null)
         abreFich.setCurrentDirectory(new File(ultimoDirectorio));
         else abreFich.setCurrentDirectory(new File("."));
         abreFich.setFileFilter(new ALLImageFilter());  
         int returnVal = abreFich.showOpenDialog(this);
         if (returnVal == abreFich.APPROVE_OPTION) 
          {
           File fich = abreFich.getSelectedFile();
           ultimoDirectorio=fich.getAbsolutePath();
           Image img=JIPToolkit.getAWTImage(fich.getAbsolutePath());
           if(img==null) return;
           JIPImage jipimg=JIPToolkit.getColorImage(img);
           jipimg.setName(fich.getName().substring(0,fich.getName().lastIndexOf(".")));
           undoSeq=new JIPSequence(canvas.GetSecuencia());
           ultimaAccion.setText("       "+"Aadido frame: "+fich.getName()); 
           canvas.addFrame(jipimg);
          }
        }
       if (e.getActionCommand().equals("Desde secuencia JIP"))
        {
         if (canvas.GetSecuencia()==null) return;
         JFileChooser abreFich = new JFileChooser();
         if (ultimoDirectorio!=null)
         abreFich.setCurrentDirectory(new File(ultimoDirectorio));
         else abreFich.setCurrentDirectory(new File("."));
         abreFich.setFileFilter(new JIPImageFilter());  
         int returnVal = abreFich.showOpenDialog(this);
         if (returnVal == abreFich.APPROVE_OPTION) 
          {
           File fich = abreFich.getSelectedFile();
           ultimoDirectorio=fich.getAbsolutePath();
           JIPSequence sec=JIPToolkit.getSeqFromFile(fich.getAbsolutePath());
           if(sec==null) return;
           undoSeq=new JIPSequence(canvas.GetSecuencia());
           ultimaAccion.setText("       "+"Aadido frame: "+sec.getName()); 
           canvas.addFrame(sec);
          }
        }
       if (e.getActionCommand().equals("Agregar bandas"))
        {
         if (canvas.GetSecuencia()==null) return;
         JFileChooser abreFich = new JFileChooser();
         if (ultimoDirectorio!=null)
         abreFich.setCurrentDirectory(new File(ultimoDirectorio));
         else abreFich.setCurrentDirectory(new File("."));
         abreFich.setFileFilter(new JIPImageFilter());  
         int returnVal = abreFich.showOpenDialog(this);
         if (returnVal == abreFich.APPROVE_OPTION) 
          {
           File fich = abreFich.getSelectedFile();
           ultimoDirectorio=fich.getAbsolutePath();
           JIPSequence sec=JIPToolkit.getSeqFromFile(fich.getAbsolutePath());
           if(sec==null) return;
           JIPImage actual=canvas.GetSecuencia().getFrame(canvas.GetFrameNum());
           JIPImage aux;
           if(actual.getType()==JIP.tCOLOR) 
             {
              new Dialogo(this).
              Error("No se pueden agregar ms bandas a un frame tipo COLOR.","ERROR");
              return;
             }

           for (int i=0;i<sec.getNumFrames();i++)
            {
             aux=sec.getFrame(i);
             if (aux.getType()!=actual.getType())
              {
               new Dialogo(this).
               Error("Existen frames en la secuencia que no son del tipo del frame a ampliar","ERROR");
               return;
              }
             if (aux.getWidth()  != actual.getWidth()   ||
                 aux.getHeight() != actual.getHeight() ) 
              {
               new Dialogo(this).
               Error("Existen frames en la secuencia con distinto tamao al frame a ampliar","ERROR");
               return;
              }
            }
           
           undoSeq=new JIPSequence(canvas.GetSecuencia());
           ultimaAccion.setText("       "+"Aadidas bandas: "+sec.getName()); 
           for(int i=0;i<sec.getNumFrames();i++)
              for(int j=0;j<sec.getFrame(i).getNumBands();j++)
                 actual.appendBand(sec.getFrame(i).getBand(j));
           canvas.ChangeFrame(actual);
          }
        }
       if (e.getActionCommand().equals("Eliminar banda"))
        {
         if (canvas.GetSecuencia()==null) return;
         JIPImage actual=canvas.GetSecuencia().getFrame(canvas.GetFrameNum());
         if(actual.getNumBands()>1) 
          {
           if(actual.getType()==JIP.tCOLOR) 
             {
              new Dialogo(this).
              Error("No se pueden eliminar bandas en un frame tipo COLOR.","ERROR");
              return;
             }
           int n = new Dialogo(this).
                   Confirmar("Desea eliminar la banda seleccionada?",
                             "Eliminar Bandas");
           if(n==0)  
             {
              undoSeq=new JIPSequence(canvas.GetSecuencia());
              ultimaAccion.setText("       "+"Eliminada banda"); 
              canvas.removeBand();
             }
          }
         else new Dialogo(this).
                  Error("No se puede dejar un frame vacio.","ERROR");
        }

       if (e.getActionCommand().equals("Eliminar frame"))
        {
         if(canvas.GetSecuencia().getNumFrames()>1) 
          {
           int n = new Dialogo(this).
                       Confirmar("Desea eliminar el frame seleccionado?",
                                "Eliminar Frames");
           if(n==0)  
             {
              undoSeq=new JIPSequence(canvas.GetSecuencia());
              ultimaAccion.setText("       "+"Eliminado frame"); 
              canvas.removeFrame();
             }
          }
         else new Dialogo(this).
                  Error("No se puede dejar una secuencia vacia.","ERROR");
        }
             
       if (e.getActionCommand().equals("Eliminar ultimo segmento"))
        { canvas.EliminarUltimoSegmento(); }
       if (e.getActionCommand().equals("Eliminar ultimo punto"))
        { canvas.EliminarUltimoPunto(); }
       if (e.getActionCommand().equals("Eliminar ultimo poligono"))
        { canvas.EliminarUltimoPoligono(); }
       if (e.getActionCommand().equals("Eliminar seleccionado"))
        { canvas.EliminarSeleccion(); }
             
       if (e.getActionCommand().equals("Aadir Geometria a Secuencia")) {
            canvas.GrabaGeometria();
       }
       if (e.getActionCommand().equals("Exportar ASCII")) {
            canvas.ExportarAscii();
       }
			 if (e.getActionCommand().equals("Importar ASCII")) {
            canvas.ImportarAscii();
       }

       if (e.getActionCommand().equals("Frame de Puntos")) {
            canvas.AadeFrameVacio(JIP.tPOINT);
       }

			 if (e.getActionCommand().equals("Frame de Segmentos")) {
            canvas.AadeFrameVacio(JIP.tSEGMENT);
       }
       
       if (e.getActionCommand().equals("Frame de Poligonos")) {
            canvas.AadeFrameVacio(JIP.tPOLY);
       }

       if (e.getActionCommand().equals("Vaciar Todos")) {
       		canvas.VaciarTodos();
       }

				if (e.getActionCommand().equals("Vaciar Puntos")) {
       		canvas.VaciarPuntos();
       }
				
			 if (e.getActionCommand().equals("Vaciar Segmentos")) {
       		canvas.VaciarSegmentos();
       }
			
				if (e.getActionCommand().equals("Vaciar Poligonos")) {
       		canvas.VaciarPoligonos();
       }
      
       if (e.getActionCommand().equals("undo"))
        { 
         if (undoSeq!=null) 
           {
            canvas.SetSecuencia(undoSeq);
            canvas.QuitarVista();
            canvas.CambiaFrame(canvas.GetFrameNum()); 
           }
         else System.out.println("Error, no hay ninguna secuencia a restaurar.");
         ultimaAccion.setText("       ninguna"); 
         undoSeq=null;
        }
       
               
        if (e.getActionCommand().equals("Acerca de..."))
				{
				
					JFrame imgfra = new JFrame("Acerca de ...");
					
					JLabel afoto= new JLabel(new Icono("/icons/Acerca_De_BG.jpg").getIcono());
					
					
					imgfra.getContentPane().add(afoto, BorderLayout.CENTER);
					imgfra.setIconImage(new Icono("/icons/vg.gif").getIcono().getImage());
					
					imgfra.pack();
					
					imgfra.setResizable(false);
					
					imgfra.setLocation(100,150);
					
					imgfra.setVisible(true);				
				}

        if(e.getActionCommand().startsWith("F_") && canvas.GetSecuencia()!=null) {            
          JIPFunction f=funclist.getJIPFunction(e.getActionCommand().substring(2));
         JIPFunctionDialogG fdialog=new JIPFunctionDialogG(this,f);
             fdialog.setVisible(true);
             int numeroFrame=canvas.GetFrameNum();
             if(fdialog.isConfirmed()) {
               if(fdialog.isAssignedOK()) {
                 if(fdialog.applyToSeq()) 
                   {
                    fdialog.setVisible(false);
                    repaint();
                    undoSeq=new JIPSequence(canvas.GetSecuencia());
                    ultimaAccion.setText("       "+f.getName()); 
                    setTitle("ViewerG - Aplicando "+f.getName()+" a "+canvas.NombreSecuencia());
                    canvas.SetSecuencia(f.processSeq(canvas.GetSecuencia()));
                    setTitle("ViewerG - "+canvas.NombreSecuencia());
                   
                    }
                 else 
                   {
                    undoSeq=new JIPSequence(canvas.GetSecuencia());
                    ultimaAccion.setText("       "+f.getName()); 
                    setTitle("ViewerG - Aplicando "+f.getName()+" al frame "+canvas.GetFrameNum()+" de "+canvas.NombreSecuencia());
                    JIPImage img=f.processImg(canvas.GetSecuencia().getFrame(canvas.GetFrameNum()));
                    canvas.GetSecuencia().setFrame(img,canvas.GetFrameNum());
                    setTitle("ViewerG - "+canvas.NombreSecuencia());
                   }
                canvas.QuitarVista();
                canvas.backGround=null;
                info.AsociaSecuencia(canvas.GetSecuencia());
                canvas.CambiaFrame(numeroFrame);
                info.SetFrame(numeroFrame);
                repaint();               
               }
               else 
                {
                 new Dialogo(this).
                 Error("Existen parmetros requeridos sin valor o valores incorrectos.","ERROR");
                 return;
               }
            }
        }

     }
	 /**<P><FONT COLOR="red">
   *<B>Descripcin:</B><BR>
   *<FONT COLOR="blue">
   *   Este es el main principal de la aplicacin. Desde aqui se llama a la clase principal
   * encargada de crear todo el sistema de mens, informacin y encargada de recibir las
   * ordenes por parte del usuario.
	 */
    
    public static void main(String[] args) 
      {
       try 
         {
            UIManager.setLookAndFeel(
                UIManager.getCrossPlatformLookAndFeelClassName());
         } catch (Exception e) {
            System.err.println("Couldn't use the cross-platform "
                             + "look and feel: " + e);
        }
        JFrame frame = new ViewerG();
        frame.setSize(800,600);
        WindowListener l = new WindowAdapter() 
          {
           public void windowClosing(WindowEvent e) 
             { System.exit(0);  }
          };
        frame.addWindowListener(l);
        frame.setVisible(true);
     }
}